#include <a_samp>
#include <a_mysql>
#include <mdialog>
#include <Pawn.CMD>
#include <streamer>
#include <sscanf2>
#include <mxDate>
#include <GoodArea>

#define public:%0(%1) 			forward%0(%1);public%0(%1)
#define IsPlayerAdminLogin(%0) 	(PlayerAdminLogin{%0} == 1)
#define IsPlayerLogin(%0) 		(PlayerLogin{%0} == 1)
#define SendUseCommand(%0,%1) 	SendClientMessage(%0, 0xBEBEBEFF, %1)
#define SendInvalidPlayer(%0) 	SendClientMessage(%0, 0xBEBEBEFF, "  ")

#define SCM                     SendClientMessage

#define COLOR_GREY              0xBEBEBEFF

#define BRAND_RED               0xBC312EFF
#define BRAND_BLUE              0x005483FF
#define BRAND_GREEN             0x5A9D36FF

native IsValidVehicle(vehicleid);

new connect;

enum(<<=1)
{
    CMD_CHAT = 1,
    CMD_ADMIN_1,
    CMD_ADMIN_2,
    CMD_ADMIN_3,
    CMD_ADMIN_4,
    CMD_ADMIN_5,
    CMD_ADMIN_6,
    CMD_ADMIN_7,
    CMD_ADMIN_8
};

enum PLAYER_INFO
{
	P_ID,
	P_NAME[MAX_PLAYER_NAME],
	P_IP[16],
	P_GENDER,
	P_SKIN,
	P_ADM_LVL,
	P_MUTE_TIME,
	P_LVL,
	P_EXP,
	P_REG_DATE,
	P_MONEY,
	P_FIRST_NAME[MAX_PLAYER_NAME],
	P_SECOND_NAME[MAX_PLAYER_NAME],
	P_BANK_MONEY
}
new Player[MAX_PLAYERS][PLAYER_INFO];

enum VEHICLE_INFO
{
	Float:V_FUEL,
	V_STATIC_TIMER,
	V_DYNAMIC_TIMER,
	Float:V_POS_X,
	Float:V_POS_Y,
	Float:V_POS_Z
}
new Vehicle[MAX_VEHICLES][VEHICLE_INFO];

#define MAX_HOUSES 1000
#define MAX_INTERIORS 1000
#define MAX_ENTERS 100
#define MAX_BANKOMATS 100
#define MAX_BIZS 300
#define MAX_BIZ_NAME 40

enum HOUSE_INFO
{
	H_ID,
	STREAMER_TAG_PICKUP:H_PICKUP,
	STREAMER_TAG_AREA:H_AREA,
	STREAMER_TAG_MAP_ICON:H_ICON,
    H_OWNER,
    H_PRICE,
    H_INTERIOR,
    H_CLASS,
    H_LOCK,
    Float:H_X,
    Float:H_Y,
    Float:H_Z,
    Float:H_A,
    H_BALANCE
}
new House[MAX_HOUSES][HOUSE_INFO];
new Houses;
new HouseGruop;

enum INTERIOR_INFO
{
	INT_ID,
	INT_NAME[40],
	INT_INTERIOR,
	Float:INT_X,
	Float:INT_Y,
	Float:INT_Z,
	Float:INT_A,
	STREAMER_TAG_AREA:INT_AREA,
	STREAMER_TAG_PICKUP:INT_PICKUP
}
new Interior[MAX_INTERIORS][INTERIOR_INFO];
new Interiors;
new InteriorGruop;

enum ENTER_INFO
{
	E_ID,
	E_NAME[40],
	Float:E_X,
	Float:E_Y,
	Float:E_Z,
	Float:E_A,
	E_INTERIOR,
	STREAMER_TAG_PICKUP:E_PICKUP,
	STREAMER_TAG_PICKUP:E_EXIT_PICKUP,
	STREAMER_TAG_AREA:E_AREA,
	E_MAP_ICON_ID,
	STREAMER_TAG_MAP_ICON:E_MAP_ICON
}
new Enter[MAX_ENTERS][ENTER_INFO];
new Enters;
new EnterGruop;

enum BANKOMAT_INFO
{
	BANK_ID,
	STREAMER_TAG_OBJECT:BANK_OBJECT,
	STREAMER_TAG_CP:BANK_CHECKPOINT
}
new Bankomat[MAX_BANKOMATS][BANKOMAT_INFO];
new Bankomats;

enum BIZ_INFO
{
	BIZ_ID,
	BIZ_NAME[MAX_BIZ_NAME],
	BIZ_OWNER,
	BIZ_TYPE,
	BIZ_INTERIOR,
	Float:BIZ_X,
	Float:BIZ_Y,
	Float:BIZ_Z,
	Float:BIZ_A,
	STREAMER_TAG_PICKUP:BIZ_PICKUP,
	STREAMER_TAG_AREA:BIZ_AREA,
	STREAMER_TAG_CP:BIZ_CP,
	BIZ_PRODUCTS
}
new Biz[MAX_BIZS][BIZ_INFO];
new Bizs;
new BizGruop;

new EditPlayerBiz[MAX_PLAYERS];

new temp_PlayerPassword[MAX_PLAYERS][32];

new PlayerAdminLogin[MAX_PLAYERS char];
new PlayerLogin[MAX_PLAYERS char];

new timer_PlayerSecond[MAX_PLAYERS];
new timer_PlayerLimitTime[MAX_PLAYERS];

new Text:LogoTD[3];

new VehEngine[MAX_VEHICLES char];
new VehLight[MAX_VEHICLES char];
new VehDoors[MAX_VEHICLES char];

new VehicleDriverID[MAX_VEHICLES];
new PlayerVehicleID[MAX_PLAYERS];

new Text:SpeedTD[5];
new PlayerText:SpeedPTD[MAX_PLAYERS][4];

new Text:SelectSkinTD[7];

new RegSkiins[2][5] = {
	{23, 1, 4, 5, 24},
	{9, 11, 12, 13, 41}
};

new timer_GlobalSecond;

new AdminVehicle[MAX_VEHICLES char];

new Text:BuyHouseTD[8];
new PlayerText:BuyHousePTD[MAX_PLAYERS][2];

new Text:GPS_TD[3];
new PlayerText:GPS_PTD[MAX_PLAYERS];
new Float:GPS_PointCords[MAX_PLAYERS][3];

#include "..\soures\textdraws\gps"

main()
{
	print("\n----------------------------------");
	print(" Blank Gamemode by your name here");
	print("----------------------------------\n");
}

public OnGameModeInit()
{
    HouseGruop = CreateGroupGoodAreas(GoodArea:HouseEnter);
    InteriorGruop = CreateGroupGoodAreas(GoodArea:InteriorExit);
    EnterGruop = CreateGroupGoodAreas(GoodArea:EnterAreas);
    BizGruop = CreateGroupGoodAreas(GoodArea:BizAreas);

    CreateDynamicObject(19126, 1083.98242, -1362.92749, 13.25386, 0.00000, 0.00000, 0.00000);
	CreateDynamicObject(19126, 1085.14209, -1362.93115, 13.25386, 0.00000, 0.00000, 0.00000);
	CreateDynamicObject(19126, 1086.40393, -1362.92920, 13.25386, 0.00000, 0.00000, 0.00000);
	CreateDynamicObject(19126, 1087.93689, -1362.93701, 13.25386, 0.00000, 0.00000, 0.00000);
	
	#include "..\soures\textdraws\logo"
	td_LoadGPS();
	
	// - 
	
	SpeedTD[0] = TextDrawCreate(516.9998, 343.3260, "LD_SPAC:white");
	TextDrawLetterSize(SpeedTD[0], 0.0, 0.0);
	TextDrawTextSize(SpeedTD[0], 42.0, 46.0);
	TextDrawColor(SpeedTD[0], -1137627393);
	TextDrawFont(SpeedTD[0], 4);

	SpeedTD[1] = TextDrawCreate(558.8330, 363.4075, "LD_SPAC:white");
	TextDrawLetterSize(SpeedTD[1], 0.0, 0.0);
	TextDrawTextSize(SpeedTD[1], 42.0, 46.0);
	TextDrawColor(SpeedTD[1], -1137627393);
	TextDrawFont(SpeedTD[1], 4);

	SpeedTD[2] = TextDrawCreate(519.3332, 346.2296, "LD_SPAC:white");
	TextDrawLetterSize(SpeedTD[2], 0.0, 0.0);
	TextDrawTextSize(SpeedTD[2], 78.8599, 60.58);
	TextDrawColor(SpeedTD[2], -1061109505);
	TextDrawFont(SpeedTD[2], 4);

	SpeedTD[3] = TextDrawCreate(525.3331, 392.8444, "light");
	TextDrawLetterSize(SpeedTD[3], 0.3786, 1.0690);
	TextDrawColor(SpeedTD[3], -1);
	TextDrawFont(SpeedTD[3], 1);
	TextDrawSetShadow(SpeedTD[3], 0);

	SpeedTD[4] = TextDrawCreate(561.9996, 392.2296, "doors");
	TextDrawLetterSize(SpeedTD[4], 0.3786, 1.0690);
	TextDrawColor(SpeedTD[4], -1);
	TextDrawFont(SpeedTD[4], 1);
	TextDrawSetShadow(SpeedTD[4], 0);
	
	// -  
	
	SelectSkinTD[0] = TextDrawCreate(266.6665, 386.6222, "Box");
	TextDrawLetterSize(SelectSkinTD[0], 0.0, 4.9666);
	TextDrawTextSize(SelectSkinTD[0], 364.4804, 0.0);
	TextDrawUseBox(SelectSkinTD[0], 1);
	TextDrawBoxColor(SelectSkinTD[0], -454564000);

	SelectSkinTD[1] = TextDrawCreate(267.9998, 392.2741, "LD_BEAT:chit");
	TextDrawLetterSize(SelectSkinTD[1], 0.0, 0.0);
	TextDrawTextSize(SelectSkinTD[1], 28.0, 33.0);
	TextDrawColor(SelectSkinTD[1], -2147483393);
	TextDrawFont(SelectSkinTD[1], 4);
	TextDrawSetSelectable(SelectSkinTD[1], true);

	SelectSkinTD[2] = TextDrawCreate(274.6999, 400.9111, "<<");
	TextDrawLetterSize(SelectSkinTD[2], 0.3389, 1.6663);
	TextDrawColor(SelectSkinTD[2], -1);
	TextDrawFont(SelectSkinTD[2], 1);
	TextDrawSetShadow(SelectSkinTD[2], 0);

	SelectSkinTD[3] = TextDrawCreate(334.9000, 392.6889, "LD_BEAT:chit");
	TextDrawLetterSize(SelectSkinTD[3], 0.0, 0.0);
	TextDrawTextSize(SelectSkinTD[3], 28.0, 33.0);
	TextDrawColor(SelectSkinTD[3], -2147483393);
	TextDrawFont(SelectSkinTD[3], 4);
	TextDrawSetSelectable(SelectSkinTD[3], true);

	SelectSkinTD[4] = TextDrawCreate(342.5002, 401.3259, ">>");
	TextDrawLetterSize(SelectSkinTD[4], 0.3389, 1.6663);
	TextDrawColor(SelectSkinTD[4], -1);
	TextDrawFont(SelectSkinTD[4], 1);
	TextDrawSetShadow(SelectSkinTD[4], 0);

	SelectSkinTD[5] = TextDrawCreate(295.0000, 399.7962, "LD_SPAC:white");
	TextDrawLetterSize(SelectSkinTD[5], 0.0, 0.0);
	TextDrawTextSize(SelectSkinTD[5], 40.0, 22.0);
	TextDrawColor(SelectSkinTD[5], -1523963137);
	TextDrawFont(SelectSkinTD[5], 4);
	TextDrawSetSelectable(SelectSkinTD[5], true);

	SelectSkinTD[6] = TextDrawCreate(298.3333, 402.5704, "select");
	TextDrawLetterSize(SelectSkinTD[6], 0.303, 1.7493);
	TextDrawColor(SelectSkinTD[6], -1);
	TextDrawFont(SelectSkinTD[6], 3);
	TextDrawSetShadow(SelectSkinTD[6], 0);
	
	// -     
	
	BuyHouseTD[0] = TextDrawCreate(497.6667, 131.5111, "Box"); // nope
	TextDrawLetterSize(BuyHouseTD[0], 0.0000, 9.9893);
	TextDrawTextSize(BuyHouseTD[0], 622.0000, 0.0000);
	TextDrawAlignment(BuyHouseTD[0], 1);
	TextDrawColor(BuyHouseTD[0], -1);
	TextDrawUseBox(BuyHouseTD[0], 1);
	TextDrawBoxColor(BuyHouseTD[0], 1381400319);
	TextDrawSetOutline(BuyHouseTD[0], 0);
	TextDrawBackgroundColor(BuyHouseTD[0], 255);
	TextDrawFont(BuyHouseTD[0], 1);
	TextDrawSetProportional(BuyHouseTD[0], 1);
	TextDrawSetShadow(BuyHouseTD[0], 0);

	BuyHouseTD[1] = TextDrawCreate(500.9997, 131.9259, "H?OPMA_O_?OME"); // nope
	TextDrawLetterSize(BuyHouseTD[1], 0.2626, 1.9650);
	TextDrawAlignment(BuyHouseTD[1], 1);
	TextDrawColor(BuyHouseTD[1], -319892993);
	TextDrawSetOutline(BuyHouseTD[1], 0);
	TextDrawBackgroundColor(BuyHouseTD[1], 255);
	TextDrawFont(BuyHouseTD[1], 2);
	TextDrawSetProportional(BuyHouseTD[1], 1);
	TextDrawSetShadow(BuyHouseTD[1], 0);

	BuyHouseTD[2] = TextDrawCreate(499.3332, 150.8518, "LD_SPAC:white"); // nope
	TextDrawLetterSize(BuyHouseTD[2], 0.0000, 0.0000);
	TextDrawTextSize(BuyHouseTD[2], 119.0000, 3.0000);
	TextDrawAlignment(BuyHouseTD[2], 1);
	TextDrawColor(BuyHouseTD[2], -168364033);
	TextDrawSetOutline(BuyHouseTD[2], 0);
	TextDrawBackgroundColor(BuyHouseTD[2], 255);
	TextDrawFont(BuyHouseTD[2], 4);
	TextDrawSetProportional(BuyHouseTD[2], 0);
	TextDrawSetShadow(BuyHouseTD[2], 0);

	BuyHouseTD[3] = TextDrawCreate(500.4000, 157.6443, "EHA:"); // nope
	TextDrawLetterSize(BuyHouseTD[3], 0.3789, 1.4714);
	TextDrawAlignment(BuyHouseTD[3], 1);
	TextDrawColor(BuyHouseTD[3], -319892993);
	TextDrawSetOutline(BuyHouseTD[3], 0);
	TextDrawBackgroundColor(BuyHouseTD[3], 255);
	TextDrawFont(BuyHouseTD[3], 1);
	TextDrawSetProportional(BuyHouseTD[3], 1);
	TextDrawSetShadow(BuyHouseTD[3], 0);

	BuyHouseTD[4] = TextDrawCreate(499.9331, 189.1444, "LD_SPAC:white"); // nope
	TextDrawLetterSize(BuyHouseTD[4], 0.0000, 0.0000);
	TextDrawTextSize(BuyHouseTD[4], 119.0000, 3.0000);
	TextDrawAlignment(BuyHouseTD[4], 1);
	TextDrawColor(BuyHouseTD[4], -168364033);
	TextDrawSetOutline(BuyHouseTD[4], 0);
	TextDrawBackgroundColor(BuyHouseTD[4], 255);
	TextDrawFont(BuyHouseTD[4], 4);
	TextDrawSetProportional(BuyHouseTD[4], 0);
	TextDrawSetShadow(BuyHouseTD[4], 0);

	BuyHouseTD[5] = TextDrawCreate(500.3333, 194.9777, "HAMTE:"); // nope
	TextDrawLetterSize(BuyHouseTD[5], 0.3223, 1.3386);
	TextDrawAlignment(BuyHouseTD[5], 1);
	TextDrawColor(BuyHouseTD[5], -319892993);
	TextDrawSetOutline(BuyHouseTD[5], 0);
	TextDrawBackgroundColor(BuyHouseTD[5], 255);
	TextDrawFont(BuyHouseTD[5], 1);
	TextDrawSetProportional(BuyHouseTD[5], 1);
	TextDrawSetShadow(BuyHouseTD[5], 0);

	BuyHouseTD[6] = TextDrawCreate(500.2666, 206.5926, "?TO?_KY?T"); // nope
	TextDrawLetterSize(BuyHouseTD[6], 0.3223, 1.3386);
	TextDrawAlignment(BuyHouseTD[6], 1);
	TextDrawColor(BuyHouseTD[6], -319892993);
	TextDrawSetOutline(BuyHouseTD[6], 0);
	TextDrawBackgroundColor(BuyHouseTD[6], 255);
	TextDrawFont(BuyHouseTD[6], 1);
	TextDrawSetProportional(BuyHouseTD[6], 1);
	TextDrawSetShadow(BuyHouseTD[6], 0);

	BuyHouseTD[7] = TextDrawCreate(557.3333, 195.3926, "H"); // nope
	TextDrawLetterSize(BuyHouseTD[7], 0.3223, 1.3386);
	TextDrawAlignment(BuyHouseTD[7], 1);
	TextDrawColor(BuyHouseTD[7], -193519105);
	TextDrawSetOutline(BuyHouseTD[7], 0);
	TextDrawBackgroundColor(BuyHouseTD[7], 255);
	TextDrawFont(BuyHouseTD[7], 1);
	TextDrawSetProportional(BuyHouseTD[7], 1);
	TextDrawSetShadow(BuyHouseTD[7], 0);
	
	for(new i; i < MAX_VEHICLES; i++)
	{
        VehicleDriverID[i] = -1;
	}
	
	DisableInteriorEnterExits();
	EnableStuntBonusForAll(0);
	ManualVehicleEngineAndLights();
	
	SetGameModeText("knox v 0.1");
	AddPlayerClass(0, 1958.3783, 1343.1572, 15.3746, 269.1425, 0, 0, 0, 0, 0, 0);
	connect = mysql_connect("127.0.0.1", "root", "knox", "123");
	
	mysql_tquery(connect, "SELECT * FROM `houses`", "LoadHouses");
	mysql_tquery(connect, "SELECT * FROM `interiors`", "LoadInteriors");
	mysql_tquery(connect, "SELECT * FROM `enters`", "LoadEnters");
	mysql_tquery(connect, "SELECT * FROM `bankomats`", "LoadBankomats");
	mysql_tquery(connect, "SELECT * FROM `bizs`", "LoadBizs");
	
	timer_GlobalSecond = SetTimer("GlobalSecondTimer", 1000, true);
	return 1;
}

public OnGameModeExit()
{
	mysql_close(connect);
	KillTimer(timer_GlobalSecond);
	return 1;
}

public OnPlayerRequestClass(playerid, classid)
{
	return 1;
}

public OnPlayerConnect(playerid)
{
	new string[42 + MAX_PLAYER_NAME];
	RemoveBuildingForPlayer(playerid, 1440, 1085.7031, -1361.0234, 13.2656, 0.25);
	for(new i; i < sizeof(LogoTD); i++) TextDrawShowForPlayer(playerid, LogoTD[i]);
	ClearPlayer(playerid);
	
	GetPlayerName(playerid, Player[playerid][P_NAME], MAX_PLAYER_NAME);
	GetPlayerIp(playerid, Player[playerid][P_IP], 16);
	
	if(!CheckPlayerName(playerid)) return 0;
	
	mysql_format(connect, string, sizeof string, "SELECT `id` FROM `users` WHERE `name`='%s'", Player[playerid][P_NAME]);
	mysql_tquery(connect, string, "IsPlayerReg", "d", playerid);
	
	ptd_LoadGPS(playerid);
	
	SpeedPTD[playerid][0] = CreatePlayerTextDraw(playerid, 521.6667, 346.8000, "123_km/h");
	PlayerTextDrawLetterSize(playerid, SpeedPTD[playerid][0], 0.4, 1.6);
	PlayerTextDrawColor(playerid, SpeedPTD[playerid][0], -1);
	PlayerTextDrawFont(playerid, SpeedPTD[playerid][0], 2);
	PlayerTextDrawSetShadow(playerid, SpeedPTD[playerid][0], 0);

	SpeedPTD[playerid][1] = CreatePlayerTextDraw(playerid, 521.6667, 361.5009, "123_l");
	PlayerTextDrawLetterSize(playerid, SpeedPTD[playerid][1], 0.4, 1.6);
	PlayerTextDrawColor(playerid, SpeedPTD[playerid][1], -1);
	PlayerTextDrawFont(playerid, SpeedPTD[playerid][1], 2);
	PlayerTextDrawSetShadow(playerid, SpeedPTD[playerid][1], 0);

	SpeedPTD[playerid][2] = CreatePlayerTextDraw(playerid, 530.3330, 380.2443, "LD_BEAT:chit"); // 
	PlayerTextDrawLetterSize(playerid, SpeedPTD[playerid][2], 0.0, 0.0);
	PlayerTextDrawTextSize(playerid, SpeedPTD[playerid][2], 14.0, 14.0);
	PlayerTextDrawColor(playerid, SpeedPTD[playerid][2], 1520252671);
	PlayerTextDrawFont(playerid, SpeedPTD[playerid][2], 4);
	PlayerTextDrawSetShadow(playerid, SpeedPTD[playerid][2], 0);

	SpeedPTD[playerid][3] = CreatePlayerTextDraw(playerid, 569.6661, 380.2443, "LD_BEAT:chit"); // 
	PlayerTextDrawLetterSize(playerid, SpeedPTD[playerid][3], 0.0, 0.0);
	PlayerTextDrawTextSize(playerid, SpeedPTD[playerid][3], 14.0, 14.0);
	PlayerTextDrawColor(playerid, SpeedPTD[playerid][3], -1137627393);
	PlayerTextDrawFont(playerid, SpeedPTD[playerid][3], 4);
	PlayerTextDrawSetShadow(playerid, SpeedPTD[playerid][3], 0);
	
	// -     
	
	BuyHousePTD[playerid][0] = CreatePlayerTextDraw(playerid, 537.5334, 156.8000, "$1000"); // nope
	PlayerTextDrawLetterSize(playerid, BuyHousePTD[playerid][0], 0.3436, 1.6580);
	PlayerTextDrawAlignment(playerid, BuyHousePTD[playerid][0], 1);
	PlayerTextDrawColor(playerid, BuyHousePTD[playerid][0], 1269383935);
	PlayerTextDrawSetOutline(playerid, BuyHousePTD[playerid][0], 0);
	PlayerTextDrawBackgroundColor(playerid, BuyHousePTD[playerid][0], 255);
	PlayerTextDrawFont(playerid, BuyHousePTD[playerid][0], 1);
	PlayerTextDrawSetProportional(playerid, BuyHousePTD[playerid][0], 1);
	PlayerTextDrawSetShadow(playerid, BuyHousePTD[playerid][0], 0);

	BuyHousePTD[playerid][1] = CreatePlayerTextDraw(playerid, 500.4000, 171.2452, "KACC:_A"); // nope
	PlayerTextDrawLetterSize(playerid, BuyHousePTD[playerid][1], 0.3789, 1.4714);
	PlayerTextDrawAlignment(playerid, BuyHousePTD[playerid][1], 1);
	PlayerTextDrawColor(playerid, BuyHousePTD[playerid][1], -319892993);
	PlayerTextDrawSetOutline(playerid, BuyHousePTD[playerid][1], 0);
	PlayerTextDrawBackgroundColor(playerid, BuyHousePTD[playerid][1], 255);
	PlayerTextDrawFont(playerid, BuyHousePTD[playerid][1], 1);
	PlayerTextDrawSetProportional(playerid, BuyHousePTD[playerid][1], 1);
	PlayerTextDrawSetShadow(playerid, BuyHousePTD[playerid][1], 0);
	
	return 1;
}

public OnPlayerDisconnect(playerid, reason)
{
	for(new i; i < sizeof(LogoTD); i++) TextDrawHideForPlayer(playerid, LogoTD[i]);
	if(IsPlayerLogin(playerid))
	{
        KillTimer(timer_PlayerSecond[playerid]);
        SavePlayer(playerid);
	}
	if(timer_PlayerLimitTime[playerid])
	{
	    KillTimer(timer_PlayerLimitTime[playerid]);
        timer_PlayerLimitTime[playerid] = 0;
	}
	return 1;
}

public OnPlayerSpawn(playerid)
{
    SetPlayerScore(playerid, Player[playerid][P_LVL]);
	SetPlayerColor(playerid, 0xFFFFFFFF);
	SetPlayerSkin(playerid, Player[playerid][P_SKIN]);
	ApplyAnimation(playerid, "FOOD", "null", 0.0, 0, 0, 0, 0, 0);
	return 1;
}

public OnPlayerDeath(playerid, killerid, reason)
{
	return 1;
}

public OnVehicleSpawn(vehicleid)
{
    SetVehicleEngine(vehicleid, 0);
	return 1;
}

public OnVehicleDeath(vehicleid, killerid)
{
	return 1;
}

public OnPlayerText(playerid, text[])
{
	new string[MAX_CHATBUBBLE_LENGTH];
	if(!IsPlayerLogin(playerid)) return 0;
	if(IsPlayerMuted(playerid)) return 0;
	format(string, sizeof string, "%s[%d]: %s", Player[playerid][P_NAME], playerid, text);
    ProxDetector(playerid, 20.0, string);
	return 0;
}

public OnPlayerEnterCheckpoint(playerid)
{
	if(GetPVarInt(playerid, !"GPS_USE"))
	{
	    DeletePVar(playerid, !"GPS_USE");
    	DisablePlayerCheckpoint(playerid);
    	for(new i = 0; i < sizeof GPS_TD; i++)
	 	{
			TextDrawHideForPlayer(playerid, GPS_TD[i]);
		}
		PlayerTextDrawHide(playerid, GPS_PTD[playerid]);
		return 1;
	}
	return 1;
}

public OnPlayerEnterVehicle(playerid, vehicleid, ispassenger)
{
	return 1;
}

public OnPlayerExitVehicle(playerid, vehicleid)
{
	VehicleDriverID[vehicleid] = -1;
	PlayerVehicleID[playerid] = 0;
	return 1;
}


public OnPlayerStateChange(playerid, newstate, oldstate)
{
	switch(newstate)
	{
		case PLAYER_STATE_DRIVER:
		{
			new
				string[14],
				veh = GetPlayerVehicleID(playerid)
			;
		    if(VehNoEng(veh))
			{
                SetVehicleEngine(veh, 1);
			}
			else
			{
				for(new i = 0; i < sizeof SpeedTD; i++)
				{
					TextDrawShowForPlayer(playerid, SpeedTD[i]);
				}
				PlayerTextDrawSetString(playerid, SpeedPTD[playerid][0], "000_km/h");
				format(string, sizeof string, "%.1f_l", Vehicle[veh][V_FUEL]);
				PlayerTextDrawSetString(playerid, SpeedPTD[playerid][1], string);
				PlayerTextDrawColor(playerid, SpeedPTD[playerid][2], VehLight{veh} ? 0x5A9D36FF : 0xBC312EFF);
				PlayerTextDrawColor(playerid, SpeedPTD[playerid][3], VehDoors{veh} ? 0x5A9D36FF : 0xBC312EFF);
				for(new i = 0; i < 4; i++)
				{
					PlayerTextDrawShow(playerid, SpeedPTD[playerid][i]);
				}
				VehicleDriverID[veh] = playerid;
				PlayerVehicleID[playerid] = veh;
			}
		}
	}
	switch(oldstate)
	{
		case PLAYER_STATE_DRIVER:
		{
            for(new i = 0; i < sizeof SpeedTD; i++)
			{
				TextDrawHideForPlayer(playerid, SpeedTD[i]);
			}
			for(new i = 0; i < 4; i++)
			{
				PlayerTextDrawHide(playerid, SpeedPTD[playerid][i]);
			}
			VehicleDriverID[PlayerVehicleID[playerid]] = -1;
			PlayerVehicleID[playerid] = 0;
		}
	}
	return 1;
}

public OnPlayerRequestSpawn(playerid)
{
	return 1;
}

public OnVehicleMod(playerid, vehicleid, componentid)
{
	return 1;
}

public OnVehiclePaintjob(playerid, vehicleid, paintjobid)
{
	return 1;
}

public OnVehicleRespray(playerid, vehicleid, color1, color2)
{
	return 1;
}
public OnPlayerInteriorChange(playerid, newinteriorid, oldinteriorid)
{
	return 1;
}

public OnPlayerKeyStateChange(playerid, newkeys, oldkeys)
{
	if(newkeys & KEY_ACTION) callcmd::engine(playerid);
	if(newkeys & KEY_FIRE) callcmd::light(playerid);
	if(newkeys & KEY_YES)
	{
		if(GetPVarInt(playerid, !"HouseTime") >= gettime())
		{
		    new
			    price = GetPVarInt(playerid, !"HousePrice"),
			    index = GetPVarInt(playerid, !"HouseIndex"),
			    user = GetPVarInt(playerid, !"HousePlayer")
		 	;
            static const frm_str[] = "{FFFFFF}\
				: %s\n\
				: $%d\n\
				: %d%c\n\
				: %d\
			";
			new string[sizeof frm_str + (MAX_PLAYER_NAME - 2) + (12 - 2) * 3 + (1 - 2) + 1];
			format(string, sizeof string, frm_str, Player[user][P_NAME], price, House[index][H_ID], GetClassLetter(House[index][H_CLASS]), House[index][H_INTERIOR]);
			Dialog_Open(playerid, Dialog:HouseBuyFromPlayer, DIALOG_STYLE_MSGBOX, !" ", string, !"", !"");
		}
	}
	if(newkeys & KEY_NO)
	{
        if(GetPVarInt(playerid, !"HouseTime") >= gettime())
        {
			static const frm_str[] = "%s    ";
			new string[sizeof frm_str + (MAX_PLAYER_NAME - 2) + 1];
            new user = GetPVarInt(playerid, !"HousePlayer");
            format(string, sizeof string, frm_str, Player[user][P_NAME]);
            SCM(user, BRAND_RED, string);
            SCM(playerid, BRAND_RED, !"    ");
			DeletePVar(playerid, !"HouseTime");
			DeletePVar(playerid, !"HousePrice");
			DeletePVar(playerid, !"HouseIndex");
			DeletePVar(playerid, !"HousePlayer");
		}
	}
	if(newkeys & KEY_CROUCH)
	{
		if(GetPlayerState(playerid) == PLAYER_STATE_DRIVER)
		{
           	new veh = GetPlayerVehicleID(playerid);
			if(Vehicle[veh][V_FUEL] < 100.0)
			{
				for(new i = 0, product; i < Bizs; i++)
				{
			        if(IsPlayerInDynamicCP(playerid, Biz[i][BIZ_CP]))
			        {
			            SetPVarInt(playerid, !"SelectBiz", i);
						if(Biz[i][BIZ_TYPE] == 2)
						{
							product = 100 - floatround(Vehicle[veh][V_FUEL]);
							if(Biz[i][BIZ_PRODUCTS] < product) return SCM(playerid, BRAND_RED, !"    ");
							SetTimerEx("SetFuel", 1000, false, "dddd", playerid, veh, i, product);
							GameTextForPlayer(playerid, "Refill...", 1000, 4);
						}
						return 1;
					}
				}
			}
		}
	}
	return 1;
}

public OnPlayerEditDynamicObject(playerid, STREAMER_TAG_OBJECT:objectid, response, Float:x, Float:y, Float:z, Float:rx, Float:ry, Float:rz)
{
	if(GetPVarInt(playerid, !"EditBankomatObject") == 1)
	{
		switch(response)
		{
			case EDIT_RESPONSE_CANCEL:
			{
				DestroyDynamicObject(objectid);
			}
			case EDIT_RESPONSE_FINAL:
			{
				static const frm_query[] = "INSERT INTO `bankomats`(`id`,`x`,`y`,`z`,`a`) VALUES (NULL,'%.2f','%.2f','%.2f','%.2f')";
				new query[sizeof frm_query + (14 - 4) * 4 + 1];
				format(query, sizeof query, frm_query, x, y, z, rz);
				mysql_query(connect, query);
				
				rz += 180.0;
				if(rz > 360.0) rz = float(floatround(rz) % 360);
				
				Bankomat[Bankomats][BANK_ID] = cache_insert_id();
				Bankomat[Bankomats][BANK_OBJECT] = objectid;
				
				
    			GetXYBehindPoint(x, y, rz, 1.0);
				Bankomat[Bankomats][BANK_CHECKPOINT] = CreateDynamicCP(x, y, z, 0.8);
				
				Bankomats++;
			}
			default: return 1;
		}
		DeletePVar(playerid, !"EditBankomatObject");
	}
	return 1;
}

public OnPlayerUpdate(playerid)
{
	if(GetPlayerState(playerid) == PLAYER_STATE_DRIVER)
	{
		new
			veh = GetPlayerVehicleID(playerid),
			string[18]
		;
        format(string, sizeof string, "%03d_km/h", GetVehicleSpeed(veh));
		PlayerTextDrawSetString(playerid, SpeedPTD[playerid][0], string);
	}
	return 1;
}

public OnPlayerStreamIn(playerid, forplayerid)
{
	return 1;
}

public OnPlayerStreamOut(playerid, forplayerid)
{
	return 1;
}

public OnVehicleStreamIn(vehicleid, forplayerid)
{
	return 1;
}

public OnVehicleStreamOut(vehicleid, forplayerid)
{
	return 1;
}

public OnPlayerClickPlayer(playerid, clickedplayerid, source)
{
	return 1;
}

public OnPlayerEnterDynamicCP(playerid, STREAMER_TAG_CP:checkpointid)
{
	for(new i = 0; i < Bankomats; i++)
	{
        if(Bankomat[i][BANK_CHECKPOINT] == checkpointid)
        {
            Dialog_Show(playerid, Dialog:BankomatMain);
			return 1;
		}
	}
	for(new i = 0; i < Bizs; i++)
	{
        if(Biz[i][BIZ_CP] == checkpointid)
        {
            SetPVarInt(playerid, !"SelectBiz", i);
			switch(Biz[i][BIZ_TYPE])
			{
				case 1:
				{
					// - 
				}
				case 2:
				{
					// - 
				}
				default:
				{
					// - 
					Dialog_Show(playerid, Dialog:CafeMenuText);
				}
			}
			return 1;
		}
	}
	return 1;
}

public OnPlayerCommandReceived(playerid, cmd[], params[], flags)
{
	if(!IsPlayerLogin(playerid))
	{
	    SendClientMessage(playerid, 0xBEBEBEFF, "  ");
        return 0;
	}
    if(flags & CMD_ADMIN_1)
	{
	    if(Player[playerid][P_ADM_LVL] < 1) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
    if(flags & CMD_ADMIN_2)
	{
	    if(Player[playerid][P_ADM_LVL] < 2) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
    if(flags & CMD_ADMIN_3)
	{
	    if(Player[playerid][P_ADM_LVL] < 3) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
    if(flags & CMD_ADMIN_4)
	{
	    if(Player[playerid][P_ADM_LVL] < 4) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
    if(flags & CMD_ADMIN_5)
	{
	    if(Player[playerid][P_ADM_LVL] < 5) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
    if(flags & CMD_ADMIN_6)
	{
	    if(Player[playerid][P_ADM_LVL] < 6) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
    if(flags & CMD_ADMIN_7)
	{
	    if(Player[playerid][P_ADM_LVL] < 7) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
    if(flags & CMD_ADMIN_8)
	{
	    if(Player[playerid][P_ADM_LVL] < 8) return 0;
     	if(!IsPlayerAdminLogin(playerid))
 		{
 		    SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 		    return 0;
 		}
	}
	if(flags & CMD_CHAT && IsPlayerMuted(playerid)) return 0;
    return 1;
}

public OnPlayerCommandPerformed(playerid, cmd[], params[], result, flags)
{
    if(result == -1)
    {
        SendClientMessage(playerid, 0xBEBEBEFF, "  !");
        return 0;
    }

    return 1;
}

public OnPlayerClickTextDraw(playerid, Text:clickedid)
{
	if(GetPVarInt(playerid, !"UseSelectSkin") == 1)
	{
	    new
	        gender = GetPVarInt(playerid, !"PlayerGender"),
	        pos = GetPVarInt(playerid, !"SelSkin_pos")
     	;
	        
	    if(clickedid == Text:INVALID_TEXT_DRAW)
	    {
			// - Esc
			
			SendClientMessage(playerid, 0xE7120EFF, "  !");
			KickEx(playerid);
		}
		if(clickedid == SelectSkinTD[1])
		{
			// - Left
			
			pos--;
			if(pos < 0) pos = 4;
			SetPlayerSkin(playerid, RegSkiins[gender][pos]);
			SetPVarInt(playerid, !"SelSkin_pos", pos);
		}
		if(clickedid == SelectSkinTD[3])
		{
			// - Right

			pos++;
			if(pos > 4) pos = 0;
			SetPlayerSkin(playerid, RegSkiins[gender][pos]);
			SetPVarInt(playerid, !"SelSkin_pos", pos);
		}
		if(clickedid == SelectSkinTD[5])
		{
			// - Select
			
			new string[250];
			SHA256_PassHash(temp_PlayerPassword[playerid], "knox-server-top", string, 64);
			mysql_format(connect, string, sizeof string, "\
				INSERT INTO `users`(`id`,`name`,`password`,`reg_ip`,`reg_data`,`gender`,`skin`) VALUES (NULL,'%s','%s','%s','%d','%d','%d')\
			", Player[playerid][P_NAME], string, Player[playerid][P_IP], gettime(), gender, RegSkiins[gender][pos]);
			mysql_query(connect, string);
			Player[playerid][P_ID] = cache_insert_id();
			format(string, sizeof string, "SELECT * FROM `users` WHERE `id`='%d'", Player[playerid][P_ID]);
			mysql_tquery(connect, string, "LoadPlayerData", "d", playerid);
			SendClientMessage(playerid, 0x527DBDFF, "   ");
			for(new i = 0; i < sizeof SelectSkinTD; i++) TextDrawHideForPlayer(playerid, SelectSkinTD[i]);
			SetPlayerVirtualWorld(playerid, 0);
			DeletePVar(playerid, !"UseSelectSkin");
			DeletePVar(playerid, !"SelSkin_pos");
			DeletePVar(playerid, !"PlayerGender");
			CancelSelectTextDraw(playerid);
		}
	}
	return 1;
}

public: IsPlayerReg(playerid)
{
	new rows, fields;
	cache_get_data(rows, fields);
	if(rows)
	{
	    new string[140];
	    Player[playerid][P_ID] = cache_get_field_content_int(0, "id");
		format(string, sizeof string, "\
			SELECT `ban_users`.*,`users`.`name` FROM `ban_users`,`users` WHERE `ban_users`.`admin`=`users`.`id` AND `ban_users`.`user`='%d'\
		", Player[playerid][P_ID]);
		mysql_tquery(connect, string, "IsPlayerBanned", "d", playerid);
	}
	else
	{
	    Dialog_Show(playerid, "PlayerRegistText");
		timer_PlayerLimitTime[playerid] = SetTimerEx("PlayerLimitTime", 5 * 60000, false, "d", playerid);
	}
	return 1;
}

public: PlayerLimitTime(playerid)
{
	Dialog_Message(playerid, " ", "{FFFFFF}\
		  / .\
	", "Ok");
	KickEx(playerid);
	timer_PlayerLimitTime[playerid] = 0;
	return 1;
}

public: IsPlayerBanned(playerid)
{
	new rows, fields;
	cache_get_data(rows, fields);
	if(rows)
	{
	    new admin[MAX_PLAYER_NAME];
	    new string[128 + sizeof(admin) + 50];
	    new data = cache_get_field_content_int(0, "data"),
			lost = cache_get_field_content_int(0, "lost");
		if(lost < gettime())
		{
			timer_PlayerLimitTime[playerid] = SetTimerEx("PlayerLimitTime", 3 * 60000, false, "d", playerid);
            Dialog_Show(playerid, "PlayerLoginText");
            format(string, sizeof string, "DELETE FROM `ban_users` WHERE `user`='%d'", Player[playerid][P_ID]);
            mysql_tquery(connect, string);
		}
		else
		{
		    cache_get_field_content(0, "name", admin);
		    cache_get_field_content(0, "reason", string);
            format(string, sizeof string, "{FFFFFF}\
				 !\n\
				: %s\n\
				 : %s\n\
				 : %s\n\
				: %s\
			", admin, date(.timestamp = data + 3600 * 6), date(.timestamp = lost), string);
			Dialog_Message(playerid, " ", string, "Ok");
	        KickEx(playerid);
		}
	}
	else
	{
        Dialog_Show(playerid, "PlayerLoginText");
		timer_PlayerLimitTime[playerid] = SetTimerEx("PlayerLimitTime", 3 * 60000, false, "d", playerid);
	}
	return 1;
}

public: LoadPlayerData(playerid)
{
    new rows, fields;
	cache_get_data(rows, fields);
	if(rows)
	{
	    Player[playerid][P_GENDER] = cache_get_field_content_int(0, "gender");
	    Player[playerid][P_SKIN] = cache_get_field_content_int(0, "skin");
	    Player[playerid][P_ADM_LVL] = cache_get_field_content_int(0, "adm_lvl");
	    Player[playerid][P_MUTE_TIME] = cache_get_field_content_int(0, "mute_time");
	    Player[playerid][P_LVL] = cache_get_field_content_int(0, "lvl");
	    Player[playerid][P_EXP] = cache_get_field_content_int(0, "exp");
	    Player[playerid][P_REG_DATE] = cache_get_field_content_int(0, "reg_data");
	    Player[playerid][P_MONEY] = cache_get_field_content_int(0, "money");
	    Player[playerid][P_BANK_MONEY] = cache_get_field_content_int(0, "bank_money");
	    SetSpawnInfo(playerid, 0, Player[playerid][P_SKIN], 1085.2888, -1332.7443, 13.6365, 202.4771, 0, 0, 0, 0, 0, 0);
		SpawnPlayer(playerid);
		timer_PlayerSecond[playerid] = SetTimerEx("PlayerSecondTimer", 1000, true, "d", playerid);
    	PlayerLogin{playerid} = 1;
		KillTimer(timer_PlayerLimitTime[playerid]);
        timer_PlayerLimitTime[playerid] = 0;
    	SetPlayerScore(playerid, Player[playerid][P_LVL]);
	}
	return 1;
}

public: PlayerSecondTimer(playerid)
{
	if(Player[playerid][P_MUTE_TIME] > 0) Player[playerid][P_MUTE_TIME]--;
	if(Player[playerid][P_MONEY] != GetPlayerMoney(playerid))
	{
	    ResetPlayerMoney(playerid);
	    GivePlayerMoney(playerid, Player[playerid][P_MONEY]);
	}
	if(GetPVarInt(playerid, !"GPS_USE"))
	{
        new
			Float:dis = GetPlayerDistanceFromPoint(playerid, GPS_PointCords[playerid][0], GPS_PointCords[playerid][1], GPS_PointCords[playerid][2]),
			string[20]
		;
	    if(dis >= 1000.0) format(string, sizeof string, "%.0f_km", dis / 1000.0);
		else format(string, sizeof string, "%.0f_m", dis);
		PlayerTextDrawSetString(playerid, GPS_PTD[playerid], string);
	}
	return 1;
}

public: GlobalSecondTimer()
{
	new _hour, _min, _sec;
	gettime(_hour, _min, _sec);
	if(_min == 0 && _sec == 0)
	{
		PayDay();
		if(_hour == 0 || _hour == 6 || _hour == 12 || _hour == 18)
		{
		    static const frm_query[] = "UPDATE `houses` SET `owner`='0',`balance`='0' WHERE `id`='%d'";
		    new query[sizeof frm_query + (12 - 2) + 1];
			for(new i = 0; i < Houses; i++)
			{
				if(House[i][H_ID] == 0) continue;
				if(House[i][H_OWNER] == 0) continue;
				House[i][H_BALANCE] -= GetClassPay(House[i][H_CLASS]);
				if(House[i][H_BALANCE] < 0)
				{
					for(new j = 0; j < MAX_PLAYERS; j++)
					{
						if(!IsPlayerConnected(j)) continue;
						if(!IsPlayerLogin(j)) continue;
						if(Player[j][P_ID] == House[i][H_OWNER])
						{
							SCM(j, 0xA52A2AFF, "      ");
							break;
						}
					}
					House[i][H_OWNER] = 0;
					House[i][H_BALANCE] = 0;
					format(query, sizeof query, frm_query, House[i][H_ID]);
					mysql_tquery(connect, query);
					DestroyDynamicPickup(House[i][H_PICKUP]);
					DestroyDynamicMapIcon(House[i][H_ICON]);
	                House[i][H_PICKUP] = CreateDynamicPickup(1273, 23, House[i][H_X], House[i][H_Y], House[i][H_Z]);
	                House[i][H_ICON] = CreateDynamicMapIcon(House[i][H_X], House[i][H_Y], House[i][H_Z], 31, -1);
				}
			}
		}
   	}
	return 1;
}

stock PayDay()
{
	for(new i = 0; i < MAX_PLAYERS; i++)
	{
		if(!IsPlayerConnected(i)) continue;
		if(!IsPlayerLogin(i)) continue;
		Player[i][P_EXP]++;
		if(Player[i][P_EXP] > GetMaxExpByLvl(Player[i][P_LVL]))
		{
            Player[i][P_EXP] = 0;
            Player[i][P_LVL]++;
			SetPlayerScore(i, Player[i][P_LVL]);
            SCM(i, BRAND_RED, "   !");
		}
	}
	return 1;
}

stock GetMaxExpByLvl(lvl)
{
	return 4 + (lvl * 4);
}

public: LoadHouses()
{
    new rows, fields;
	cache_get_data(rows, fields);
	if(rows) {
	    new Float:x, Float:y, Float:z;
	    for(new i = 0; i < rows; i++)
	    {
        	House[i][H_ID] = cache_get_field_content_int(i, "id");
        	House[i][H_OWNER] = cache_get_field_content_int(i, "owner");
        	House[i][H_INTERIOR] = cache_get_field_content_int(i, "interior");
        	House[i][H_PRICE] = cache_get_field_content_int(i, "price");
        	House[i][H_CLASS] = cache_get_field_content_int(i, "class");
        	House[i][H_BALANCE] = cache_get_field_content_int(i, "balance");
        	House[i][H_LOCK] = cache_get_field_content_int(i, "house_lock");
		 	x = cache_get_field_content_float(i, "x");
		 	y = cache_get_field_content_float(i, "y");
		 	z = cache_get_field_content_float(i, "z");
		 	House[i][H_X] = x;
		 	House[i][H_Y] = y;
		 	House[i][H_Z] = z;
		 	House[i][H_A] = cache_get_field_content_float(i, "a");
		 	if(House[i][H_OWNER] == 0)
		 	{
                House[i][H_PICKUP] = CreateDynamicPickup(1273, 23, x, y, z);
                House[i][H_ICON] = CreateDynamicMapIcon(x, y, z, 31, -1);
			}
		 	else
		 	{
                House[i][H_PICKUP] = CreateDynamicPickup(19522, 23, x, y, z);
                House[i][H_ICON] = CreateDynamicMapIcon(x, y, z, 32, -1);
			}
		 	House[i][H_AREA] = CreateDynamicSphere(x, y, z, 1.5);
		 	AddGroupGoodAreas(HouseGruop, House[i][H_AREA], i);
		}
		Houses = rows;
	}
	return 1;
}

stock GetClassPay(classid)
{
	switch(classid)
	{
		case 0: return 100;
		case 1: return 70;
		case 2: return 40;
	}
	return 20;
}

public: LoadInteriors()
{
    new rows, fields;
	cache_get_data(rows, fields);
	if(rows) {
        for(new i = 0; i < rows; i++)
        {
            Interior[i][INT_ID] = cache_get_field_content_int(i, "id");
            Interior[i][INT_INTERIOR] = cache_get_field_content_int(i, "interior");
            cache_get_field_content(i, "name", Interior[i][INT_NAME]);
		 	Interior[i][INT_X] = cache_get_field_content_float(i, "x");
		 	Interior[i][INT_Y] = cache_get_field_content_float(i, "y");
		 	Interior[i][INT_Z] = cache_get_field_content_float(i, "z");
		 	Interior[i][INT_A] = cache_get_field_content_float(i, "a");
		 	Interior[i][INT_AREA] = CreateDynamicSphere(Interior[i][INT_X], Interior[i][INT_Y], Interior[i][INT_Z], 0.8);
		 	AddGroupGoodAreas(InteriorGruop, Interior[i][INT_AREA], i);
		}
		Interiors = rows;
	}
	return 1;
}

public: LoadEnters()
{
	new rows, fields;
	cache_get_data(rows, fields);
	if(rows) {
		for(new i = 0; i < rows; i++)
		{
			Enter[i][E_ID] = cache_get_field_content_int(i, "id");
			Enter[i][E_MAP_ICON_ID] = cache_get_field_content_int(i, "map_icon");
            cache_get_field_content(i, "name", Enter[i][E_NAME]);
		 	Enter[i][E_X] = cache_get_field_content_float(i, "x");
		 	Enter[i][E_Y] = cache_get_field_content_float(i, "y");
		 	Enter[i][E_Z] = cache_get_field_content_float(i, "z");
		 	Enter[i][E_A] = cache_get_field_content_float(i, "a");
			Enter[i][E_INTERIOR] = cache_get_field_content_int(i, "interior");
			Enter[i][E_PICKUP] = CreateDynamicPickup(19133, 23, Enter[i][E_X], Enter[i][E_Y], Enter[i][E_Z]);
		 	Enter[i][E_AREA] = CreateDynamicSphere(Enter[i][E_X], Enter[i][E_Y], Enter[i][E_Z], 0.8);
		 	AddGroupGoodAreas(EnterGruop, Enter[i][E_AREA], i);
		 	Enter[i][E_EXIT_PICKUP] = CreateInteriorPickup(Enter[i][E_INTERIOR], MAX_HOUSES + i);
		 	if(Enter[i][E_MAP_ICON_ID] != 0)
		 	{
		 		Enter[i][E_MAP_ICON] = CreateDynamicMapIcon(Enter[i][E_X], Enter[i][E_Y], Enter[i][E_Z], Enter[i][E_MAP_ICON_ID], -1);
		 	}
		}
		Enters = rows;
		printf(": %d", Enters);
	}
	return 1;
}

public: LoadBankomats()
{
	new rows, fields;
	cache_get_data(rows, fields);
	if(rows) {
		new Float:x, Float:y, Float:z, Float:a;
		for(new i = 0; i < rows; i++)
		{
		 	x = cache_get_field_content_float(i, "x");
		 	y = cache_get_field_content_float(i, "y");
		 	z = cache_get_field_content_float(i, "z");
		 	a = cache_get_field_content_float(i, "a");
		    Bankomat[i][BANK_OBJECT] = CreateDynamicObject(2942, x, y, z, 0.0, 0.0, a);
		    
			a += 180.0;
			if(a > 360.0) a = float(floatround(a) % 360);
			
			GetXYBehindPoint(x, y, a, 1.0);
			Bankomat[i][BANK_CHECKPOINT] = CreateDynamicCP(x, y, z, 0.8);
		}
		Bankomats = rows;
	}
	return 1;
}

public: LoadBizs()
{
	new rows, fields;
	cache_get_data(rows, fields);
	if(!rows) return print("  ");
	new Float:x, Float:y, Float:z, Float:a;
	for(new i = 0; i < rows; i++)
	{
		Biz[i][BIZ_ID] = cache_get_field_content_int(i, "id");
		Biz[i][BIZ_OWNER] = cache_get_field_content_int(i, "owner");
		Biz[i][BIZ_TYPE] = cache_get_field_content_int(i, "type");
		Biz[i][BIZ_INTERIOR] = cache_get_field_content_int(i, "interior");
		Biz[i][BIZ_PRODUCTS] = cache_get_field_content_int(i, "products");
		cache_get_field_content(i, "name", Biz[i][BIZ_NAME]);
	 	x = cache_get_field_content_float(i, "x");
	 	y = cache_get_field_content_float(i, "y");
	 	z = cache_get_field_content_float(i, "z");
	 	a = cache_get_field_content_float(i, "a");
		Biz[i][BIZ_X] = x;
		Biz[i][BIZ_Y] = y;
		Biz[i][BIZ_Z] = z;
		Biz[i][BIZ_A] = a;
		Biz[i][BIZ_PICKUP] = CreateDynamicPickup(19135, 23, x, y, z);
		Biz[i][BIZ_AREA] = CreateDynamicSphere(x, y, z, 1.5);
		AddGroupGoodAreas(BizGruop, Biz[i][BIZ_AREA], i);
	 	x = cache_get_field_content_float(i, "use_x");
	 	y = cache_get_field_content_float(i, "use_y");
	 	z = cache_get_field_content_float(i, "use_z");
		if(floatcmp(x, 0.0) != 0 || floatcmp(y, 0.0) != 0)
		{
			if(Biz[i][BIZ_TYPE] == 2)
				Biz[i][BIZ_CP] = CreateDynamicCP(x, y, z, 2.0);
			else
				Biz[i][BIZ_CP] = CreateDynamicCP(x, y, z, 1.0, MAX_HOUSES + MAX_ENTERS + i);
		}
	}
	Bizs = rows;
	return 1;
}

stock CreateInteriorPickup(interior, world)
{
    for(new i = 0; i < Interiors; i++)
	{
		if(Interior[i][INT_ID] != interior) continue;
		return CreateDynamicPickup(19133, 23, Interior[i][INT_X], Interior[i][INT_Y], Interior[i][INT_Z], world);
	}
	return 0;
}

stock GoToInterior(playerid, interior)
{
	for(new i = 0; i < Interiors; i++)
	{
		if(Interior[i][INT_ID] != interior) continue;
		SetPlayerInterior(playerid, Interior[i][INT_INTERIOR]);
		SetPlayerPos(playerid, Interior[i][INT_X], Interior[i][INT_Y], Interior[i][INT_Z]);
		SetPlayerFacingAngle(playerid, Interior[i][INT_A]);
		return 1;
	}
	return 0;
}

stock ProxDetector(playerid, Float:radius, text[], color1 = 0xFFFFFFFF, color2 = 0xEAEAEAFF)
{
	new Float:x, Float:y, Float:z;
	GetPlayerPos(playerid, x, y, z);
	new world = GetPlayerVirtualWorld(playerid),
	    interior = GetPlayerInterior(playerid);
	for(new i; i < MAX_PLAYERS; i++)
	{
		if(!IsPlayerConnected(i)) continue;
		if(!IsPlayerInRangeOfPoint(i, radius, x, y, z)) continue;
		if(world != GetPlayerVirtualWorld(i)) continue;
		if(interior != GetPlayerInterior(i)) continue;
		if(IsPlayerInRangeOfPoint(i, radius / 2, x, y, z))
		{
            SendClientMessage(i, color1, text);
		}
		else
		{
            SendClientMessage(i, color2, text);
		}
	}
	return 1;
}

stock IsPlayerInRangeOfPlayer(playerid, user, Float:radius)
{
	new Float:x, Float:y, Float:z;
	GetPlayerPos(playerid, x, y, z);
	return IsPlayerInRangeOfPoint(user, radius, x, y, z);
}

stock ClearPlayer(playerid)
{
    PlayerAdminLogin{playerid} = 0;
    PlayerLogin{playerid} = 0;
    Player[playerid][P_MONEY] = 0;
	return 1;
}

stock CheckPlayerName(playerid)
{
	new name[MAX_PLAYER_NAME], first_name[MAX_PLAYER_NAME], second_name[MAX_PLAYER_NAME], number_count = 0, check = 0;
	format(name, sizeof name, Player[playerid][P_NAME]);
	if(name[0] < 'A' || name[0] > 'Z')
	{
		SCM(playerid, BRAND_RED, !"     Nick_Name");
		KickEx(playerid);
		return 0;
	}
	for(new i = 0, len = strlen(name); i < len; i++)
	{
	    if(name[i] >= '0' && name[i] <= '9')
		{
		    if(number_count >= 3)
			{
                SCM(playerid, BRAND_RED, !"     ");
				KickEx(playerid);
				return 0;
			}
            number_count++;
		}
		if(name[i] == '_')
		{
			if(check != 0) 
			{
                SCM(playerid, BRAND_RED, !"     Nick_Name");
				KickEx(playerid);
				return 0;
			}
			else
			{
			    if(i + 1 > len)
			    {
                    SCM(playerid, BRAND_RED, !"     Nick_Name");
					KickEx(playerid);
					return 0;
				}
                check = i + 1;
                if(name[i + 1] < 'A' || name[i + 1] > 'Z')
				{
					SCM(playerid, BRAND_RED, !"     Nick_Name");
					KickEx(playerid);
					return 0;
				}
			}
		}
		else
		{
			if(check == 0)
			{
				first_name[i] = name[i];
			}
			else
			{
                second_name[i - check] = name[i];
			}
		}
	}
	if(check == 0)
	{
		SCM(playerid, BRAND_RED, !"     Nick_Name");
		KickEx(playerid);
		return 0;
	}
	format(Player[playerid][P_FIRST_NAME], MAX_PLAYER_NAME, first_name);
	format(Player[playerid][P_SECOND_NAME], MAX_PLAYER_NAME, second_name);
	return 1;
}

stock SendAdminMessage(color, text[], adm_lvl = 1)
{
	if(adm_lvl < 1) return 1;
	for(new i = 0; i < MAX_PLAYERS; i++)
	{
		if(!IsPlayerConnected(i)) continue;
		if(Player[i][P_ADM_LVL] < adm_lvl) continue;
		if(!IsPlayerAdminLogin(i)) continue;
		SendClientMessage(i, color, text);
	}
	return 1;
}

stock IsPlayerMuted(playerid)
{
	if(Player[playerid][P_MUTE_TIME] > 0)
	{
	    new time = Player[playerid][P_MUTE_TIME];
	    if(time <= 60)
	    {
            SendClientMessage(playerid, 0xBEBEBEFF, " !     ");
		}
		else
		{
			new string[MAX_CHATBUBBLE_LENGTH];
			format(string, sizeof string, " !     %d .", floatround(time / 60));
            SendClientMessage(playerid, 0xBEBEBEFF, string);
		}
		return 1;
	}
	return 0;
}

stock SavePlayer(playerid)
{
	static frm_str[] = " UPDATE `users` SET `mute_time`='%d',`lvl`='%d',`exp`='%d',`money`='%d' WHERE `id`='%d'";
	new string[sizeof(frm_str) + (12 - 2) * 5 + 1];
	mysql_format(connect, string, sizeof string, frm_str, Player[playerid][P_MUTE_TIME], Player[playerid][P_LVL], Player[playerid][P_EXP], Player[playerid][P_MONEY], Player[playerid][P_ID]);
	mysql_tquery(connect, string);
	return 1;
}

stock VehNoEng(veh)
{
	switch(GetVehicleModel(veh))
	{
		case 481, 509, 510, 460, 476, 511, 512, 417: return 1;
	}
	return 0;
}

stock SetVehicleEngine(vehicle, status)
{
	if(status)
	{
		if(VehEngine{vehicle} == 0)
		{
			Vehicle[vehicle][V_STATIC_TIMER] = SetTimerEx("VehicleStaticTimer", 2000, true, "d", vehicle);
			Vehicle[vehicle][V_DYNAMIC_TIMER] = SetTimerEx("VehicleDynamicTimer", 500, true, "d", vehicle);
			new Float:x, Float:y, Float:z;
			GetVehiclePos(vehicle, x, y, z);
            Vehicle[vehicle][V_POS_X] = x;
            Vehicle[vehicle][V_POS_Y] = y;
            Vehicle[vehicle][V_POS_Z] = z;
		}
	}
	else
	{
        if(VehEngine{vehicle} == 1)
        {
			KillTimer(Vehicle[vehicle][V_STATIC_TIMER]);
			KillTimer(Vehicle[vehicle][V_DYNAMIC_TIMER]);
		}
	}
 	VehEngine{vehicle} = status;
    SetVehicleParamsEx(vehicle, status, -1, -1, -1, -1, -1, -1);
	return 1;
}

public: VehicleStaticTimer(vehicle)
{
	Vehicle[vehicle][V_FUEL] -= 0.05;
	new playerid = VehicleDriverID[vehicle];
	if(playerid != -1)
	{
	    new string[26];
	    format(string, sizeof string, "%.1f_l", Vehicle[vehicle][V_FUEL]);
		PlayerTextDrawSetString(playerid, SpeedPTD[playerid][1], string);
	}
	if(Vehicle[vehicle][V_FUEL] <= 0.0) SetVehicleEngine(vehicle, 0);
	return 1;
}

public: VehicleDynamicTimer(vehicle)
{
	new Float:x, Float:y, Float:z;
	GetVehiclePos(vehicle, x, y, z);
	if(DistancePointToPoint(x, y, z, Vehicle[vehicle][V_POS_X], Vehicle[vehicle][V_POS_Y], Vehicle[vehicle][V_POS_Z]) > 10)
	{
        Vehicle[vehicle][V_FUEL] -= 0.01;
		new playerid = VehicleDriverID[vehicle];
		if(playerid != -1)
		{
		    new string[26];
		    format(string, sizeof string, "%.1f_l", Vehicle[vehicle][V_FUEL]);
			PlayerTextDrawSetString(playerid, SpeedPTD[playerid][1], string);
		}
		if(Vehicle[vehicle][V_FUEL] <= 0.0) SetVehicleEngine(vehicle, 0);
		Vehicle[vehicle][V_POS_X] = x;
        Vehicle[vehicle][V_POS_Y] = y;
		Vehicle[vehicle][V_POS_Z] = z;
	}
	return 1;
}

stock SetVehicleLight(vehicle, status)
{
	VehLight{vehicle} = status;
    SetVehicleParamsEx(vehicle, -1, status, -1, -1, -1, -1, -1);
	new playerid = VehicleDriverID[vehicle];
	if(playerid != -1)
	{
        PlayerTextDrawColor(playerid, SpeedPTD[playerid][2], status ? 0x5A9D36FF : 0xBC312EFF);
		PlayerTextDrawReload(playerid, SpeedPTD[playerid][2]);
	}
	return 1;
}

stock SetVehicleDoors(vehicle, status)
{
	VehDoors{vehicle} = status;
    SetVehicleParamsEx(vehicle, -1, -1, -1, status, -1, -1, -1);
	new playerid = VehicleDriverID[vehicle];
	if(playerid != -1)
	{
        PlayerTextDrawColor(playerid, SpeedPTD[playerid][3], status ? 0x5A9D36FF : 0xBC312EFF);
		PlayerTextDrawReload(playerid, SpeedPTD[playerid][3]);
	}
	return 1;
}

stock GetVehicleSpeed(vehicle)//by Frog163
{
	new Float:x, Float:y, Float:z;
	GetVehicleVelocity(vehicle, x, y, z);
	return floatround(floatsqroot(x*x+y*y+z*z)*195);
}

stock DistancePointToPoint(Float:x, Float:y, Float:z, Float:fx, Float:fy, Float:fz)
{
	x = floatpower(fx - x, 2);
	y = floatpower(fy - y, 2);
	z = floatpower(fz - z, 2);
	return floatround(floatsqroot(x + y + z));
}

stock PlayerTextDrawReload(playerid, PlayerText:temp_ptd)
{
	PlayerTextDrawHide(playerid, temp_ptd);
	PlayerTextDrawShow(playerid, temp_ptd);
	return 1;
}

stock ShowPlayerStat(playerid, userid, dialogName[] = "PlayerStat")
{
	new string[180];
	new lvl = Player[userid][P_LVL];
	format(string, sizeof string, "{FFFFFF}:\t\t\t{BC312E}%s\n", Player[userid][P_NAME]);
	format(string, sizeof string, "%s{FFFFFF}:\t\t\t{BC312E}%s\n", string, Player[userid][P_GENDER] ? ("") : (""));
	format(string, sizeof string, "%s{FFFFFF} :\t{BC312E}%s\n", string, date(.timestamp = Player[userid][P_REG_DATE] + 3600 * 6));
	format(string, sizeof string, "%s{FFFFFF}:\t\t{BC312E}%d(%d/%d)\n", string, lvl, Player[userid][P_EXP], GetMaxExpByLvl(lvl));
	Dialog_Open(playerid, dialogName, DIALOG_STYLE_MSGBOX, " ", string, "", "");
	return 1;
}

stock HideHouseInfo(playerid)
{
    for(new i = 0; i < sizeof BuyHouseTD; i++)
	{
		TextDrawHideForPlayer(playerid, BuyHouseTD[i]);
	}
	for(new i = 0; i < sizeof BuyHousePTD[]; i++)
	{
		PlayerTextDrawHide(playerid, BuyHousePTD[playerid][i]);
	}
	return 1;
}

stock db_UpdateData(const table_name[], const column_name[], column_data, id)
{
	static frm_str[] = "UPDATE `%s` SET `%s`='%d' WHERE `id`='%d'";
	new string[sizeof(frm_str) + (30 + 2) * 2 + (12 - 2) * 2 + 1];
	mysql_format(connect, string, sizeof string, frm_str, table_name, column_name, column_data, id);
	mysql_tquery(connect, string);
	return 1;
}

stock IsVehicleBuzy(veh)
{
    new playerid = VehicleDriverID[veh];
    if(!IsPlayerConnected(playerid)) return 0;
    if(!IsPlayerInVehicle(playerid, veh)) return 0;
    return 1;
}

stock GetXYBehindPoint(&Float:x, &Float:y, Float:a, Float:distance)
{
	x += (distance * floatsin(-a, degrees));
	y += (distance * floatcos(-a, degrees));
	return 1;
}

stock GivePlayerHealth(playerid, amount)
{
	new Float:health;
	GetPlayerHealth(playerid, health);
	health += float(amount);
	if(health > 100.0) health = 100.0;
	SetPlayerHealth(playerid, health);
	return 1;
}

public: SetFuel(playerid, vehicle, index, product)
{
	new veh = GetPlayerVehicleID(playerid);
	if(veh != vehicle) return 1;
	if(GetPlayerState(playerid) != PLAYER_STATE_DRIVER) return 1;
	if(!IsPlayerInDynamicCP(playerid, Biz[index][BIZ_CP])) return 1;
	if(Biz[index][BIZ_PRODUCTS] < product) return SCM(playerid, BRAND_RED, !"    ");
	Biz[index][BIZ_PRODUCTS] -= product;
	db_UpdateData("bizs", "products", Biz[index][BIZ_ID], Biz[index][BIZ_PRODUCTS]);
	Vehicle[veh][V_FUEL] = 100.0;
	Player[playerid][P_MONEY] -= product * 2;
	db_UpdateData("users", "money", Player[playerid][P_ID], Player[playerid][P_MONEY]);
	return 1;
}

// ============================== [ Kick ] =====================================

stock KickEx(playerid)
{
	new ping = GetPlayerPing(playerid);
	if(ping > 2500) ping = 2500;
 	else if(ping < 200) ping = 200;
    SetTimerEx("KickPlayer", ping, false, "d", playerid);
    return 1;
}

public: KickPlayer(playerid)
{
	return Kick(playerid);
}

// ============================== [ .  ] ================================

GAResponse:HouseEnter(playerid, response, key, index)
{
	switch(response)
	{
	    case GA_RESPONSE_PRESS_KEY:
	    {
			if(key & KEY_WALK)
			{
			    if(House[index][H_LOCK] == 0 || House[index][H_OWNER] == 0)
			    {
			        GoToInterior(playerid, House[index][H_INTERIOR]);
					SetPlayerVirtualWorld(playerid, index);
			    }
			}
			if(key & KEY_CTRL_BACK)
			{
                if(House[index][H_OWNER] == 0)
                {
                    for(new i = 0; i < Houses; i++)
                    {
						if(House[i][H_OWNER] == Player[playerid][P_ID]) return SCM(playerid, BRAND_RED, !"    ");
					}
					if(House[index][H_PRICE] > Player[playerid][P_MONEY])
					{
		 				SCM(playerid, BRAND_RED, !"      !");
						return 1;
					}
					Player[playerid][P_MONEY] -= House[index][H_PRICE];
					House[index][H_OWNER] = Player[playerid][P_ID];
					DestroyDynamicMapIcon(House[index][H_ICON]);
					DestroyDynamicPickup(House[index][H_PICKUP]);
					House[index][H_PICKUP] = CreateDynamicPickup(19522, 23, House[index][H_X], House[index][H_Y], House[index][H_Z]);
                	House[index][H_ICON] = CreateDynamicMapIcon(House[index][H_X], House[index][H_Y], House[index][H_Z], 32, -1);
					HideHouseInfo(playerid);
					db_UpdateData("houses", "owner", Player[playerid][P_ID], House[index][H_ID]);
				}
			}
		}
		case GA_RESPONSE_ENTER:
		{
			if(House[index][H_OWNER] == 0)
			{
			    new string[12];
				for(new i = 0; i < sizeof BuyHouseTD; i++)
				{
					TextDrawShowForPlayer(playerid, BuyHouseTD[i]);
				}
				format(string, sizeof string, "$%d", House[index][H_PRICE]);
				PlayerTextDrawSetString(playerid, BuyHousePTD[playerid][0], string);
				switch(House[index][H_CLASS])
				{
					case 0: PlayerTextDrawSetString(playerid, BuyHousePTD[playerid][1], "KACC:_A");
					case 1: PlayerTextDrawSetString(playerid, BuyHousePTD[playerid][1], "KACC:_B");
					case 2: PlayerTextDrawSetString(playerid, BuyHousePTD[playerid][1], "KACC:_C");
					default: PlayerTextDrawSetString(playerid, BuyHousePTD[playerid][1], "KACC:_D");
				}
				for(new i = 0; i < sizeof BuyHousePTD[]; i++)
				{
					PlayerTextDrawShow(playerid, BuyHousePTD[playerid][i]);
				}
			}
		}
		case GA_RESPONSE_LEAVE:
		{
            HideHouseInfo(playerid);
		}
	}
	return 1;
}

GAResponse:InteriorExit(playerid, response, key, index)
{
	switch(response)
	{
	    case GA_RESPONSE_PRESS_KEY:
	    {
			if(key & KEY_WALK)
			{
				new world = GetPlayerVirtualWorld(playerid);
				if(world < MAX_HOUSES)
				{
					SetPlayerInterior(playerid, 0);
					SetPlayerVirtualWorld(playerid, 0);
					SetPlayerPos(playerid, House[world][H_X], House[world][H_Y], House[world][H_Z]);
					SetPlayerFacingAngle(playerid, House[world][H_A]);
				}
				else if(world < MAX_HOUSES + MAX_ENTERS)
				{
				    world -= MAX_HOUSES;
                    SetPlayerInterior(playerid, 0);
					SetPlayerVirtualWorld(playerid, 0);
					SetPlayerPos(playerid, Enter[world][E_X], Enter[world][E_Y], Enter[world][E_Z]);
					SetPlayerFacingAngle(playerid, Enter[world][E_A]);
				}
				else if(world < MAX_HOUSES + MAX_ENTERS + MAX_BIZS)
				{
				    world -= MAX_HOUSES + MAX_ENTERS;
                    SetPlayerInterior(playerid, 0);
					SetPlayerVirtualWorld(playerid, 0);
					SetPlayerPos(playerid, Biz[world][BIZ_X], Biz[world][BIZ_Y], Biz[world][BIZ_Z]);
					SetPlayerFacingAngle(playerid, Biz[world][BIZ_A]);
				}
			}
		}
	}
	return 1;
}

GAResponse:EnterAreas(playerid, response, key, index)
{
	switch(response)
	{
	    case GA_RESPONSE_PRESS_KEY:
	    {
			if(key & KEY_WALK)
			{
				GoToInterior(playerid, Enter[index][E_INTERIOR]);
				SetPlayerVirtualWorld(playerid, MAX_HOUSES + index);
			}
		}
	}
	return 1;
}

GAResponse:BizAreas(playerid, response, key, index)
{
	switch(response)
	{
	    case GA_RESPONSE_PRESS_KEY:
	    {
			if(key & KEY_WALK)
			{
				GoToInterior(playerid, Biz[index][BIZ_INTERIOR]);
				SetPlayerVirtualWorld(playerid, MAX_HOUSES + MAX_ENTERS + index);
			}
		}
	}
	return 1;
}

// ============================== [  ] ==================================

DialogCreate:CafeMenuText(playerid)
{
	Dialog_Open(playerid, Dialog:CafeMenu, DIALOG_STYLE_TABLIST_HEADERS, !" ", !"\
		\t\n\
		{FFFFFF}\t{BADB4D}$500\n\
		{FFFFFF}\t{BADB4D}$100\n\
		{FFFFFF}\t{BADB4D}$200\n\
		{FFFFFF}\t{BADB4D}$300\
	", !"", !"");
	return 1;
}

DialogResponse:CafeMenu(playerid, response, listitem, inputtext[])
{
	if(!response) return 0;
	new
	    price,
	    amount,
	    product,
	    index = GetPVarInt(playerid, !"SelectBiz")
 	;
	switch(listitem)
	{
		case 0:
		{
		    price = 500;
		    amount = 80;
		    product = 50;
		}
		case 1:
		{
		    price = 100;
		    amount = 20;
		    product = 10;
		}
		case 2:
		{
		    price = 200;
		    amount = 50;
		    product = 20;
		}
		default:
		{
		    price = 300;
		    amount = 60;
		    product = 30;
		}
	}
	if(Biz[index][BIZ_PRODUCTS] < product) return SCM(playerid, BRAND_RED, !"    ");
	if(price > Player[playerid][P_MONEY]) return SCM(playerid, BRAND_RED, !"  ");
	new Float:health;
	GetPlayerHealth(playerid, health);
	if(health > 90.0) return SCM(playerid, BRAND_RED, !" ");
    Player[playerid][P_MONEY] -= price;
	db_UpdateData("users", "money", Player[playerid][P_ID], Player[playerid][P_MONEY]);
	Biz[index][BIZ_PRODUCTS] -= product;
	db_UpdateData("bizs", "products", Biz[index][BIZ_ID], Biz[index][BIZ_PRODUCTS]);
	GivePlayerHealth(playerid, amount);
	ApplyAnimation(playerid, "FOOD", "EAT_Burger", 3.0, 0, 0, 0, 0, 0);
	return 1;
}

DialogCreate:BankomatMain(playerid)
{
	Dialog_Open(playerid, Dialog:BankomantMainRes, DIALOG_STYLE_LIST, !"", !"{FFFFFF}\
		1.  \n\
		2.   \n\
		3.   \n\
		4.  \
	", !"", !"");
	return 1;
}

DialogResponse:BankomantMainRes(playerid, response, listitem, inputtext[])
{
	if(!response) return 1;
	switch(listitem)
	{
		case 0:
		{
			new check_house, house_balance;
			for(new i = 0; i < Houses; i++)
			{
				if(House[i][H_ID] == 0) continue;
				if(House[i][H_OWNER] != Player[playerid][P_ID]) continue;
				check_house = 1;
				house_balance = House[i][H_BALANCE];
				break;
			}
			if(check_house)
			{
                static const frm_str[] = "{FFFFFF}\
					   {A7E347}$%d{FFFFFF}\n\
					 : {A7E347}$%d\
				";
				new string[sizeof frm_str + (12 - 2) * 2 + 1];
				format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY], house_balance);
	 			Dialog_Open(playerid, Dialog:BankomantMainBack, DIALOG_STYLE_MSGBOX, !"", string, !"", !"");
			}
			else
			{
                static const frm_str[] = "{FFFFFF}\
					   {A7E347}$%d\
				";
				new string[sizeof frm_str + (12 - 2) + 1];
				format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY]);
	 			Dialog_Open(playerid, Dialog:BankomantMainBack, DIALOG_STYLE_MSGBOX, !"", string, !"", !"");
			}
		}
		case 1:
		{
		    static const frm_str[] = "{FFFFFF}\
				   {A7E347}$%d{FFFFFF}\n\
				      :\
			";
			new string[sizeof frm_str + (12 - 2) + 1];
			format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY]);
 			Dialog_Open(playerid, Dialog:BankomantAdd, DIALOG_STYLE_INPUT, !"", string, !"", !"");
		}
		case 2:
		{
		    static const frm_str[] = "{FFFFFF}\
				   {A7E347}$%d{FFFFFF}\n\
				       :\
			";
			new string[sizeof frm_str + (12 - 2) + 1];
			format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY]);
 			Dialog_Open(playerid, Dialog:BankomantSnat, DIALOG_STYLE_INPUT, !"", string, !"", !"");
		}
		case 3:
		{
			Dialog_Show(playerid, Dialog:BankomantHouseText);
		}
	}
	return 1;
}

DialogCreate:BankomantHouseText(playerid)
{
    new check_house = -1;
	for(new i = 0; i < Houses; i++)
	{
		if(House[i][H_ID] == 0) continue;
		if(House[i][H_OWNER] != Player[playerid][P_ID]) continue;
		check_house = i;
		break;
	}

	if(check_house == -1)
	{
	    SCM(playerid, BRAND_RED, !"   !");
		return Dialog_Show(playerid, Dialog:BankomatMain);
	}
    static const frm_str[] = "{FFFFFF}\
		 : {A7E347}$%d{FFFFFF}\n\
		        :\
	";
	new string[sizeof frm_str + (12 - 2) + 1];
	format(string, sizeof string, frm_str, House[check_house][H_BALANCE]);
	Dialog_Open(playerid, Dialog:BankomantHouse, DIALOG_STYLE_INPUT, !"", string, !"", !"");
	return 1;
}

DialogResponse:BankomantHouse(playerid, response, listitem, inputtext[])
{
	if(!response) return Dialog_Show(playerid, Dialog:BankomatMain);
	new val = strval(inputtext);
	if(val <= 0) return Dialog_Show(playerid, Dialog:BankomantHouseText);
	if(val > Player[playerid][P_BANK_MONEY])
	{
	    SCM(playerid, BRAND_RED, !"     ");
	    return Dialog_Show(playerid, Dialog:BankomantHouseText);
	}
	
	new check_house = -1;
	for(new i = 0; i < Houses; i++)
	{
		if(House[i][H_ID] == 0) continue;
		if(House[i][H_OWNER] != Player[playerid][P_ID]) continue;
		check_house = i;
		break;
	}

	if(check_house == -1) return Dialog_Show(playerid, Dialog:BankomatMain);
	
	new max_balance = GetClassPay(House[check_house][H_CLASS]) * 30;
	if(House[check_house][H_BALANCE] + val > max_balance)
	{
	    static const frm_str1[] = "      {A7E347}$%d";
	    new string1[sizeof frm_str1 + (12 - 2) + 1];
	    format(string1, sizeof string1, frm_str1, max_balance);
	    SCM(playerid, 0xFFFFFFFF, string1);
		return Dialog_Show(playerid, Dialog:BankomantHouseText);
	}
	
	House[check_house][H_BALANCE] += val;
	Player[playerid][P_BANK_MONEY] -= val;

	db_UpdateData("users", "bank_money", Player[playerid][P_ID], Player[playerid][P_BANK_MONEY]);
	db_UpdateData("houses", "balance", House[check_house][H_ID], House[check_house][H_BALANCE]);
	
	static const frm_str3[] = "     {A7E347}$%d{FFFFFF}.    {A7E347}$%d";
	new string3[sizeof frm_str3 + (12 - 2) * 2 + 1];
	format(string3, sizeof string3, frm_str3, val, House[check_house][H_BALANCE]);

	static const frm_str2[] = "  : {A7E347}$%d";
	new string2[sizeof frm_str2 + (12 - 2) * 3 + 1];
	format(string2, sizeof string2, frm_str2, Player[playerid][P_BANK_MONEY] );
	
	SCM(playerid, -1, !" ");
	SCM(playerid, BRAND_BLUE, !"----------------------------------------------  -----------------------------------------------");
	SCM(playerid, -1, !" ");
	SCM(playerid, 0xEAEAEAFF, string3);
	SCM(playerid, 0xEAEAEAFF, string2);
	SCM(playerid, -1, !" ");
	SCM(playerid, BRAND_BLUE, !"===================================================");
	SCM(playerid, -1, !" ");
	
	return 1;
}

DialogResponse:BankomantSnat(playerid, response, listitem, inputtext[])
{
	if(!response) return Dialog_Show(playerid, Dialog:BankomatMain);
	new val = strval(inputtext);
	if(val <= 0)
	{
	    static const frm_str[] = "{FFFFFF}\
			   {A7E347}$%d{FFFFFF}\n\
			      :\n\n\
			{E31223}    !\
		";
		new string[sizeof frm_str + (12 - 2) + 1];
		format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY]);
		Dialog_Open(playerid, Dialog:BankomantAdd, DIALOG_STYLE_INPUT, !"", string, !"", !"");
		return 1;
	}
	if(val > Player[playerid][P_BANK_MONEY])
	{
	    static const frm_str[] = "{FFFFFF}\
			   {A7E347}$%d{FFFFFF}\n\
			      :\n\n\
			{E31223}       !\
		";
		new string[sizeof frm_str + (12 - 2) + 1];
		format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY]);
		Dialog_Open(playerid, Dialog:BankomantAdd, DIALOG_STYLE_INPUT, !"", string, !"", !"");
		return 1;
	}
	new proc = floatround(val * 0.05);
	Player[playerid][P_MONEY] += (val - proc);
	Player[playerid][P_BANK_MONEY] -= val;
	
	db_UpdateData("users", "bank_money", Player[playerid][P_ID], Player[playerid][P_BANK_MONEY]);

	static const frm_str1[] = "    {A7E347}$%d{EAEAEA},  {A7E347}$%d{EAEAEA},  {A7E347}$%d{EAEAEA}";
	new string1[sizeof frm_str1 + (12 - 2) * 3 + 1];
	format(string1, sizeof string1, frm_str1, val, proc, (val - proc));

	static const frm_str2[] = "  : {A7E347}$%d";
	new string2[sizeof frm_str2 + (12 - 2) * 3 + 1];
	format(string2, sizeof string2, frm_str2, Player[playerid][P_BANK_MONEY] );

	SCM(playerid, -1, !" ");
	SCM(playerid, BRAND_BLUE, !"----------------------------------------------  -----------------------------------------------");
	SCM(playerid, -1, !" ");
	SCM(playerid, 0xEAEAEAFF, string1);
	SCM(playerid, 0xEAEAEAFF, string2);
	SCM(playerid, -1, !" ");
	SCM(playerid, BRAND_BLUE, !"===================================================");
	SCM(playerid, -1, !" ");
	return 1;
}

DialogResponse:BankomantAdd(playerid, response, listitem, inputtext[])
{
	if(!response) return Dialog_Show(playerid, Dialog:BankomatMain);
	new val = strval(inputtext);
	if(val <= 0)
	{
	    static const frm_str[] = "{FFFFFF}\
			   {A7E347}$%d{FFFFFF}\n\
			      :\n\n\
			{E31223}    !\
		";
		new string[sizeof frm_str + (12 - 2) + 1];
		format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY]);
		Dialog_Open(playerid, Dialog:BankomantAdd, DIALOG_STYLE_INPUT, !"", string, !"", !"");
		return 1;
	}
	if(val > Player[playerid][P_MONEY])
	{
	    static const frm_str[] = "{FFFFFF}\
			   {A7E347}$%d{FFFFFF}\n\
			      :\n\n\
			{E31223}    !\
		";
		new string[sizeof frm_str + (12 - 2) + 1];
		format(string, sizeof string, frm_str, Player[playerid][P_BANK_MONEY]);
		Dialog_Open(playerid, Dialog:BankomantAdd, DIALOG_STYLE_INPUT, !"", string, !"", !"");
		return 1;
	}
	new proc = floatround(val * 0.05);
	Player[playerid][P_MONEY] -= val;
	Player[playerid][P_BANK_MONEY] += (val - proc);
	
	db_UpdateData("users", "bank_money", Player[playerid][P_ID], Player[playerid][P_BANK_MONEY]);
	
	static const frm_str1[] = "    {A7E347}$%d{EAEAEA},  {A7E347}$%d{EAEAEA},  {A7E347}$%d{EAEAEA}";
	new string1[sizeof frm_str1 + (12 - 2) * 3 + 1];
	format(string1, sizeof string1, frm_str1, val, proc, (val - proc));
	
	static const frm_str2[] = "  : {A7E347}$%d";
	new string2[sizeof frm_str2 + (12 - 2) * 3 + 1];
	format(string2, sizeof string2, frm_str2, Player[playerid][P_BANK_MONEY] );
	
	SCM(playerid, -1, !" ");
	SCM(playerid, BRAND_BLUE, !"----------------------------------------------  -----------------------------------------------");
	SCM(playerid, -1, !" ");
	SCM(playerid, 0xEAEAEAFF, string1);
	SCM(playerid, 0xEAEAEAFF, string2);
	SCM(playerid, -1, !" ");
	SCM(playerid, BRAND_BLUE, !"===================================================");
	SCM(playerid, -1, !" ");
	return 1;
}

DialogResponse:BankomantMainBack(playerid, response, listitem, inputtext[])
{
	if(response) Dialog_Show(playerid, Dialog:BankomatMain);
	return 1;
}

// -   

DialogCreate:AdminCreatePassText(playerid)
{
	Dialog_Open(playerid, "AdminCreatePass", DIALOG_STYLE_INPUT, " ", "{FFFFFF}\
		   :\
	", "", "");
	return 1;
}

DialogResponse:AdminCreatePass(playerid, response, listitem, inputtext[])
{
	new len = strlen(inputtext);
	if(len < 4 || len > 24)
	{
	    Dialog_Show(playerid, "AdminCreatePassText");
		return SCM(playerid, COLOR_GREY, "     4  24 ");
	}
	new string[150];
	format(string, sizeof string, "knox-%d-top", Player[playerid][P_ID]);
	SHA256_PassHash(inputtext, string, string, 64);
	format(string, sizeof string, "UPDATE `users` SET `adm_pass`='%s' WHERE `id`='%d'", string, Player[playerid][P_ID]);
	mysql_tquery(connect, string);
	PlayerAdminLogin{playerid} = 1;
	format(string, sizeof string, "     %d ", Player[playerid][P_ADM_LVL]);
    SendClientMessage(playerid, 0x527DBDFF, string);
    format(string, sizeof string, " %s    %d ", Player[playerid][P_NAME], Player[playerid][P_ADM_LVL]);
    SendAdminMessage(0xEA3752FF, string);
	return 1;
}

// -  

DialogCreate:AdminLoginText(playerid)
{
    Dialog_Open(playerid, "AdminLogin", DIALOG_STYLE_PASSWORD, " ", "{FFFFFF}\
		   :\
	", "", "");
    return 1;
}

DialogResponse:AdminLogin(playerid, response, listitem, inputtext[])
{
	if(!response) return 0;
	new string[150];
	format(string, sizeof string, "knox-%d-top", Player[playerid][P_ID]);
	SHA256_PassHash(inputtext, string, string, 64);
	mysql_format(connect, string, sizeof string, "\
		SELECT 1 FROM `users` WHERE `id`='%d' AND `adm_pass`='%s'\
	", Player[playerid][P_ID], string);
	new Cache:cache = mysql_query(connect, string);
	if(cache_get_row_count(connect) <= 0) {
	    new count = GetPVarInt(playerid, "AdmPasswordCount");
	    count++;
	    if(count >= 3) {
			SendClientMessage(playerid, 0xE7120EFF, "      !");
			SendClientMessage(playerid, 0xE7120EFF, "      ");
			return KickEx(playerid);
		}
		format(string, sizeof string, "   . : %d", 3 - count);
		SendClientMessage(playerid, 0xE7120EFF, string);
		SetPVarInt(playerid, "AdmPasswordCount", count);
		Dialog_Show(playerid, "AdminLoginText");
		return cache_delete(cache);
	}
	cache_delete(cache);
	PlayerAdminLogin{playerid} = 1;
	format(string, sizeof string, "     %d ", Player[playerid][P_ADM_LVL]);
    SendClientMessage(playerid, 0x527DBDFF, string);
    format(string, sizeof string, " %s    %d ", Player[playerid][P_NAME], Player[playerid][P_ADM_LVL]);
    SendAdminMessage(0xEA3752FF, string);
    DeletePVar(playerid, "AdmPasswordCount");
	return 1;
}

// - 

DialogCreate:PlayerRegistText(playerid)
{
 	new string[100 + MAX_PLAYER_NAME];
    format(string, sizeof string, "{FFFFFF}\
		 {B219D8}%s{FFFFFF}  !\n\
		    :\
	", Player[playerid][P_NAME]);
    Dialog_Open(playerid, "PlayerRegist", DIALOG_STYLE_INPUT, "", string, "", "");
    return 1;
}

DialogResponse:PlayerRegist(playerid, response, listitem, inputtext[])
{
	if(!response) {
		SendClientMessage(playerid, 0xE7120EFF, "  !");
		return KickEx(playerid);
	}
	new len = strlen(inputtext);
	if(len < 6) {
        Dialog_Show(playerid, "PlayerRegistText");
		return SendClientMessage(playerid, 0xE7120EFF, "    6- ");
	}
	if(len > 32) {
        Dialog_Show(playerid, "PlayerRegistText");
		return SendClientMessage(playerid, 0xE7120EFF, "    32- ");
	}
	format(temp_PlayerPassword[playerid], 32, inputtext);
	Dialog_Open(playerid, "PlayerRegistGender", DIALOG_STYLE_MSGBOX, "", "{FFFFFF} ?", "", "");
	return 1;
}

DialogResponse:PlayerRegistGender(playerid, response, listitem, inputtext[])
{
	for(new i = 0; i < sizeof SelectSkinTD; i++) TextDrawShowForPlayer(playerid, SelectSkinTD[i]);
	SetSpawnInfo(playerid, 0, RegSkiins[response][0], 2125.5269, -1741.5144, 17.0204, 11.7410, 0, 0, 0, 0, 0, 0);
	if(GetPlayerState(playerid) == PLAYER_STATE_SPECTATING) TogglePlayerSpectating(playerid, 0);
	else SpawnPlayer(playerid);
	SetPVarInt(playerid, !"PlayerGender", response);
	SetPVarInt(playerid, !"UseSelectSkin", 1);
	SetPVarInt(playerid, !"SelSkin_pos", 0);
	SetPlayerCameraPos(playerid, 2124.0417, -1738.8684, 17.0204);
	SetPlayerCameraLookAt(playerid, 2125.5269, -1741.5144, 17.0204);
	SetPlayerVirtualWorld(playerid, playerid + 99999000);
	SelectTextDraw(playerid, 0xBEBEBE60);
    return 1;
}

// - 

DialogCreate:PlayerLoginText(playerid)
{
 	new string[100 + MAX_PLAYER_NAME];
    format(string, sizeof string, "{FFFFFF}\
		 {BC312E}%s{FFFFFF} !\n\
		   :\
	", Player[playerid][P_NAME]);
    Dialog_Open(playerid, "PlayerLogin", DIALOG_STYLE_PASSWORD, "{192F82}", string, "", "");
    return 1;
}

DialogResponse:PlayerLogin(playerid, response, listitem, inputtext[])
{
	if(!response) {
		SendClientMessage(playerid, 0xE7120EFF, "  !");
		return KickEx(playerid);
	}
	new string[250];
	SHA256_PassHash(inputtext, "knox-server-top", string, 64);
	mysql_format(connect, string, sizeof string, "SELECT 1 FROM `users` WHERE `name`='%s' AND `password`='%s'", Player[playerid][P_NAME], string);
	new Cache:cache = mysql_query(connect, string);
	if(cache_get_row_count(connect) <= 0) {
	    new count = GetPVarInt(playerid, "PasswordCount");
	    count++;
	    if(count >= 3) {
			SendClientMessage(playerid, 0xE7120EFF, "     !");
			SendClientMessage(playerid, 0xE7120EFF, "      ");
			return KickEx(playerid);
		}
		format(string, sizeof string, "   . : %d", 3 - count);
		SendClientMessage(playerid, 0xE7120EFF, string);
		SetPVarInt(playerid, "PasswordCount", count);
		Dialog_Show(playerid, "PlayerLoginText");
		return cache_delete(cache);
	}
	cache_delete(cache);
	format(string, sizeof string, "SELECT * FROM `users` WHERE `name`='%s'", Player[playerid][P_NAME]);
	mysql_tquery(connect, string, "LoadPlayerData", "d", playerid);
    return 1;
}

DialogResponse:SendReport(playerid, response, listitem, inputtext[])
{
	if(!response) return 0;
	if(strlen(inputtext) < 3) return SendClientMessage(playerid, 0xBEBEBEFF, " /  .");
 	new string[MAX_CHATBUBBLE_LENGTH];
 	format(string, sizeof string, "[report] %s[%d]: %s", Player[playerid][P_NAME], playerid, inputtext);
	SendAdminMessage(0xEA3752FF, string);
	SendClientMessage(playerid, 0x527DBDFF, " /   .");
	SetPVarInt(playerid, "report_time_block", gettime() + 5 * 60);
	return 1;
}

DialogCreate:PlayerSettingText(playerid)
{
    Dialog_Open(playerid, Dialog:PlayerSettings, DIALOG_STYLE_LIST, "{BC312E}",  "\
		{BC312E}{FFFFFF} \
	", "", "");
	return 1;
}

DialogCreate:ChangePass1Text(playerid)
{
    Dialog_Open(playerid, Dialog:ChangePass1, DIALOG_STYLE_PASSWORD, "{BC312E} ",  "{FFFFFF}\
		    ,    :\
	", "", "");
	return 1;
}

DialogCreate:ChangePass2Text(playerid)
{
    Dialog_Open(playerid, Dialog:ChangePass2, DIALOG_STYLE_PASSWORD, "{BC312E} ",  "{FFFFFF}\
		   {BC312E}{FFFFFF} :\
	", "", "");
	return 1;
}

DialogCreate:CMDMainText(playerid)
{
    Dialog_Open(playerid, Dialog:CMDMain, DIALOG_STYLE_LIST, "{BC312E} ",  "{FFFFFF}\
		 \n\
		 \n\
		\
	", "", "");
	return 1;
}

DialogResponse:MainMenu(playerid, response, listitem, inputtext[])
{
	if(!response) return 1;
	switch(listitem)
	{
		case 0:
		{
			// - 
			ShowPlayerStat(playerid, playerid);
		}
		case 1:
		{
			// - 
			Dialog_Show(playerid, "CMDMainText");
		}
		case 2:
		{
			// - 
			Dialog_Show(playerid, "PlayerSettingText");
		}
	}
	return 1;
}

DialogResponse:PlayerStat(playerid, response, listitem, inputtext[])
{
	if(response) callcmd::mm(playerid);
	return 1;
}

DialogResponse:PlayerSettings(playerid, response, listitem, inputtext[])
{
	if(!response) return callcmd::mm(playerid);
	switch(listitem)
	{
		case 0:
		{
			// -  
			Dialog_Show(playerid, "ChangePass1Text");
		}
	}
	return 1;
}

DialogResponse:ChangePass1(playerid, response, listitem, inputtext[])
{
	if(!response) return Dialog_Show(playerid, "PlayerSettingText");
	new string[250];
	SHA256_PassHash(inputtext, "knox-server-top", string, 64);
	mysql_format(connect, string, sizeof string, "SELECT 1 FROM `users` WHERE `name`='%s' AND `password`='%s'", Player[playerid][P_NAME], string);
	new Cache:cache = mysql_query(connect, string);
	if(cache_get_row_count(connect) <= 0) {
		Dialog_Show(playerid, "ChangePass1Text");
		return cache_delete(cache);
	}
	cache_delete(cache);
	Dialog_Show(playerid, "ChangePass2Text");
	return 1;
}

DialogResponse:ChangePass2(playerid, response, listitem, inputtext[])
{
	if(!response) return Dialog_Show(playerid, "PlayerSettingText");
    new len = strlen(inputtext);
	if(len < 6) {
        Dialog_Show(playerid, "ChangePass2Text");
		return SendClientMessage(playerid, 0xE7120EFF, "    6- ");
	}
	if(len > 32) {
        Dialog_Show(playerid, "ChangePass2Text");
		return SendClientMessage(playerid, 0xE7120EFF, "    32- ");
	}
	new string[250];
	SHA256_PassHash(inputtext, "knox-server-top", string, 64);
	format(string, sizeof string, "UPDATE `users` SET `password`='%q' WHERE `id`='%d'", string, Player[playerid][P_ID]);
	mysql_tquery(connect, string);
	format(string, sizeof string, "    {BC312E}%s", inputtext);
	SCM(playerid, BRAND_BLUE, string);
	SCM(playerid, BRAND_BLUE, " !   (F8)");
	return 1;
}

DialogResponse:CMDMain(playerid, response, listitem, inputtext[])
{
	if(!response) return callcmd::mm(playerid);
	switch(listitem)
	{
		case 0:
		{
			// -  
			Dialog_Open(playerid, Dialog:CMDBackMain, DIALOG_STYLE_MSGBOX, "{BC312E} ",  "{FFFFFF}\
				{FFFFFF}/s - {BC312E}\n\
				{FFFFFF}/do - {BC312E}\n\
				{FFFFFF}/me - {BC312E}\n\
				{FFFFFF}/try - {BC312E}  \n\
			", "", "");
		}
		case 1:
		{
			// -  
			Dialog_Open(playerid, Dialog:CMDBackMain, DIALOG_STYLE_MSGBOX, "{BC312E} ",  "{FFFFFF}\
				{FFFFFF}/engine - {BC312E}/ \n\
				{FFFFFF}/light - {BC312E}/ \n\
			", "", "");
		}
		case 2:
		{
			// - 
			Dialog_Open(playerid, Dialog:CMDBackMain, DIALOG_STYLE_MSGBOX, "{BC312E} ",  "{FFFFFF}\
				{FFFFFF}/admins - {BC312E}  \n\
				{FFFFFF}/report - {BC312E} /\n\
			", "", "");
		}
	}
	return 1;
}

DialogResponse:CMDBackMain(playerid, response, listitem, inputtext[])
{
	if(response) Dialog_Show(playerid, "CMDMainText");
	return 1;
}

// -  

DialogResponse:EditHouse(playerid, response, listitem, inputtext[])
{
	if(!response) return 1;
	switch(listitem)
	{
	    case 0:
	    {
			// - 
			Dialog_Open(playerid, Dialog:EditHouseInt, DIALOG_STYLE_INPUT, !"{BC312E} ", !"{FFFFFF}\
				  :\
			", !"", !"");
		}
		case 1:
		{
			// - 
			Dialog_Open(playerid, Dialog:EditHouseClass, DIALOG_STYLE_LIST, !"{BC312E} {FFFFFF} | ", !"{FFFFFF}\
				 \n\
				 B\n\
				 C\n\
				 D\
			", !"", !"");
		}
		case 2:
		{
			// - 
			Dialog_Open(playerid, Dialog:EditHousePrice, DIALOG_STYLE_INPUT, !"{BC312E} ", !"{FFFFFF}\
				  :\
			", !"", !"");
		}
	}
	return 1;
}

DialogResponse:EditHouseInt(playerid, response, listitem, inputtext[])
{
	if(!response) return callcmd::edithouse(playerid);
	new val = strval(inputtext);
	if(val < 1)
	{
	    Dialog_Open(playerid, Dialog:EditHouseInt, DIALOG_STYLE_INPUT, !"{BC312E} ", !"{FFFFFF}\
			  :\n\n\
			{FF5F5F}  !\
		", !"", !"");
	    return 1;
	}
	new index = GetPVarInt(playerid, !"HouseIndex");
	db_UpdateData("houses", "interior", val, House[index][H_ID]);
	House[index][H_INTERIOR] = val;
	static const frm_str[] = "    %d  %d";
	new string[sizeof(frm_str) + (12 - 2) * 2 + 1];
	format(string, sizeof string, frm_str, House[index][H_ID], val);
	SCM(playerid, 0xFF5F5FFF, string);
	return 1;
}

DialogResponse:EditHouseClass(playerid, response, listitem, inputtext[])
{
	if(!response) return callcmd::edithouse(playerid);
	new index = GetPVarInt(playerid, !"HouseIndex");
	db_UpdateData("houses", "class", listitem, House[index][H_ID]);
	House[index][H_CLASS] = listitem;
	static const frm_str[] = "    %d  %s";
	new string[sizeof(frm_str) + (12 - 2) * 2 + 1];
	switch(listitem)
	{
		case 0: format(string, sizeof string, "A");
		case 1: format(string, sizeof string, "B");
		case 2: format(string, sizeof string, "C");
		default: format(string, sizeof string, "D");
	}
	format(string, sizeof string, frm_str, House[index][H_ID], string);
	SCM(playerid, 0xFF5F5FFF, string);
	return 1;
}

DialogResponse:EditHousePrice(playerid, response, listitem, inputtext[])
{
	if(!response) return callcmd::edithouse(playerid);
	new val = strval(inputtext);
	if(val < 1)
	{
	    Dialog_Open(playerid, Dialog:EditHousePrice, DIALOG_STYLE_INPUT, !"{BC312E} ", !"{FFFFFF}\
			  :\n\
			{FF5F5F} !\
		", !"", !"");
	    return 1;
	}
	new index = GetPVarInt(playerid, !"HouseIndex");
	db_UpdateData("houses", "price", val, House[index][H_ID]);
	House[index][H_PRICE] = val;
	static const frm_str[] = "    %d  %d";
	new string[sizeof(frm_str) + (12 - 2) * 2 + 1];
	format(string, sizeof string, frm_str, House[index][H_ID], val);
	SCM(playerid, 0xFF5F5FFF, string);
	return 1;
}

DialogResponse:HouseMenu(playerid, response, listitem, inputtext[])
{
	if(!response) return 1;
	new index = GetPVarInt(playerid, !"HouseIndex");
	switch(listitem)
	{
		case 0:
		{
		    new string[MAX_PLAYER_NAME + 8];
			if(House[index][H_LOCK])
			{
                House[index][H_LOCK] = 0;
                format(string, sizeof string, "%s ", Player[playerid][P_NAME]);
			}
			else
			{
                House[index][H_LOCK] = 1;
                format(string, sizeof string, "%s ", Player[playerid][P_NAME]);
			}
   			ProxDetector(playerid, 20.0, string, 0xE46EEAFF, 0xE46EEAFF);
			db_UpdateData("houses", "house_lock", House[index][H_LOCK], House[index][H_ID]);
		}
		case 1:
		{
			// -  
			static const frm_str[] = "{FFFFFF}      {5A9D36}$%d{FFFFFF}?";
			new string[sizeof frm_str + (12 - 2) + 1];
			format(string, sizeof string, frm_str, floatround(House[index][H_PRICE] * 0.5));
			Dialog_Open(playerid, Dialog:HouseSellToGov, DIALOG_STYLE_MSGBOX, !" ", string, !"", !"");
		}
		case 2:
		{
			// -  
			Dialog_Show(playerid, Dialog:HouseSellToPlayerText);
		}
	}
	return 1;
}

DialogCreate:HouseSellToPlayerText(playerid)
{
	Dialog_Open(playerid, Dialog:HouseSellToPlayer, DIALOG_STYLE_INPUT, !" ", "{FFFFFF}\
		 id      :\
	", !"", !"");
	return 1;
}

DialogCreate:HouseSellToPlayerPriceText(playerid)
{
	static const frm_str[] = "{FFFFFF}\
	    : %s\n\
		  :\
	";
	new
		string[sizeof frm_str + (MAX_PLAYER_NAME - 2) + 1],
		user = GetPVarInt(playerid, !"HouseSellUser")
	;
	format(string, sizeof string, frm_str, Player[user][P_NAME]);
	Dialog_Open(playerid, Dialog:HouseSellToPlayerPrice, DIALOG_STYLE_INPUT, !" ", string, !"", !"");
	return 1;
}

DialogResponse:HouseSellToPlayer(playerid, response, listitem, inputtext[])
{
	if(!response) return callcmd::hmenu(playerid);
	new
	    user
 	;
 	if(sscanf(inputtext, "u", user)) {
 		SCM(playerid, BRAND_RED, !"   id ");
 	    Dialog_Show(playerid, Dialog:HouseSellToPlayerText);
		return 1;
	}
 	if(user == INVALID_PLAYER_ID) {
 		SendInvalidPlayer(playerid);
 	    Dialog_Show(playerid, Dialog:HouseSellToPlayerText);
		return 1;
	}
	if(!IsPlayerInRangeOfPlayer(playerid, user, 4.0)) {
 		SCM(playerid, BRAND_RED, !"  ");
 	    Dialog_Show(playerid, Dialog:HouseSellToPlayerText);
		return 1;
	}
	SetPVarInt(playerid, !"HouseSellUser", user);
	Dialog_Show(playerid, Dialog:HouseSellToPlayerPriceText);
	return 1;
}

DialogResponse:HouseSellToPlayerPrice(playerid, response, listitem, inputtext[])
{
	if(!response) return Dialog_Show(playerid, Dialog:HouseSellToPlayerText);
	new
		val = strval(inputtext),
		user = GetPVarInt(playerid, !"HouseSellUser"),
	    index = GetPVarInt(playerid, !"HouseIndex")
	;
	if(val <= 0) {
	    SCM(playerid, BRAND_RED, !"    ");
    	return Dialog_Show(playerid, Dialog:HouseSellToPlayerPriceText);
	}
	if(GetPVarInt(playerid, !"HouseTime") >= gettime())
	{
        return SCM(playerid, BRAND_GREEN, !"      ");
	}
	for(new i = 0; i < Houses; i++)
    {
		if(House[i][H_OWNER] == Player[user][P_ID]) return SCM(playerid, BRAND_RED, !"    ");
	}
	SCM(playerid, BRAND_GREEN, !"  ");
	SCM(user, BRAND_GREEN, !"     . Y(/accept house) -   N - ");
	SetPVarInt(user, !"HousePrice", val);
	SetPVarInt(user, !"HouseIndex", index);
	SetPVarInt(user, !"HousePlayer", playerid);
	SetPVarInt(user, !"HouseTime", gettime() + 30);
	return 1;
}

cmd:accept(playerid, params[])
{
	if(strcmp(params, "house") == 0) {
		new
		    price = GetPVarInt(playerid, !"HousePrice"),
		    index = GetPVarInt(playerid, !"HouseIndex"),
		    user = GetPVarInt(playerid, !"HousePlayer")
	 	;
		if(GetPVarInt(playerid, !"HouseTime") < gettime()) return SCM(playerid, BRAND_RED, !" ");
	    static const frm_str[] = "{FFFFFF}\
			: %s\n\
			: $%d\n\
			: %d%c\n\
			: %d\
		";
		new string[sizeof frm_str + (MAX_PLAYER_NAME - 2) + (12 - 2) * 3 + (1 - 2) + 1];
		format(string, sizeof string, frm_str, Player[user][P_NAME], price, House[index][H_ID], GetClassLetter(House[index][H_CLASS]), House[index][H_INTERIOR]);
		Dialog_Open(playerid, Dialog:HouseBuyFromPlayer, DIALOG_STYLE_MSGBOX, !" ", string, !"", !"");
	}
	return 1;
}

DialogResponse:HouseBuyFromPlayer(playerid, response, listitem, inputtext[])
{
	new
	    price = GetPVarInt(playerid, !"HousePrice"),
	    index = GetPVarInt(playerid, !"HouseIndex"),
	    user = GetPVarInt(playerid, !"HousePlayer")
 	;
	if(!response) return 1;
	if(GetPVarInt(playerid, !"HouseTime") < gettime()) return SCM(playerid, BRAND_RED, !" ");
	if(Player[playerid][P_MONEY] < price) return SCM(playerid, BRAND_RED, !"   ");
	if(House[index][H_OWNER] != Player[user][P_ID]) return 1;
	for(new i = 0; i < Houses; i++)
    {
		if(House[i][H_OWNER] == Player[playerid][P_ID]) return SCM(playerid, BRAND_RED, !"    ");
	}
	Player[playerid][P_MONEY] -= price;
	Player[user][P_MONEY] += price;
	House[index][H_OWNER] = Player[playerid][P_ID];
	db_UpdateData("houses", "owner", Player[playerid][P_ID], House[index][H_ID]);
	
	SCM(playerid, BRAND_GREEN, !"  ,      ");
	SCM(user, BRAND_GREEN, !"  !");
	return 1;
}

stock GetClassLetter(classid)
{
	switch(classid)
	{
		case 0: return 'A';
		case 1: return 'B';
		case 2: return 'C';
	}
	return 'D';
}

DialogResponse:HouseSellToGov(playerid, response, listitem, inputtext[])
{
	new index = GetPVarInt(playerid, !"HouseIndex");
	if(!response) return callcmd::hmenu(playerid);
	static const frm_query[] = "UPDATE `houses` SET `owner`='0',`balance`='0' WHERE `id`='%d'";
    new query[sizeof frm_query + (12 - 2) + 1];
	House[index][H_OWNER] = 0;
	House[index][H_BALANCE] = 0;
	format(query, sizeof query, frm_query, House[index][H_ID]);
	mysql_tquery(connect, query);
	DestroyDynamicPickup(House[index][H_PICKUP]);
	DestroyDynamicMapIcon(House[index][H_ICON]);
    House[index][H_PICKUP] = CreateDynamicPickup(1273, 23, House[index][H_X], House[index][H_Y], House[index][H_Z]);
    House[index][H_ICON] = CreateDynamicMapIcon(House[index][H_X], House[index][H_Y], House[index][H_Z], 31, -1);
    
    new price = floatround(House[index][H_PRICE] * 0.5);
    
	Player[playerid][P_MONEY] += price;
	
	static const frm_str[] = "    {5A9D36}$%d";
	new string[sizeof frm_str + (12 - 2) + 1];
	format(string, sizeof string, frm_str, price);
	SCM(playerid, BRAND_GREEN, string);
	return 1;
}

DialogResponse:GPS(playerid, response, listitem, inputtext[])
{
	if(!response) return 1;
	switch(listitem)
 	{
 	    case 0:
 	    {
            GPS_PointCords[playerid][0] = Enter[0][E_X];
            GPS_PointCords[playerid][1] = Enter[0][E_Y];
            GPS_PointCords[playerid][2] = Enter[0][E_Z];
		}
		default: return 1;
 	}
 	SetPlayerCheckpoint(playerid, GPS_PointCords[playerid][0], GPS_PointCords[playerid][1], GPS_PointCords[playerid][2], 1.5);
 	SetPVarInt(playerid, !"GPS_USE", 1);
    new
		Float:dis = GetPlayerDistanceFromPoint(playerid, GPS_PointCords[playerid][0], GPS_PointCords[playerid][1], GPS_PointCords[playerid][2]),
		string[20]
	;
    if(dis >= 1000.0) format(string, sizeof string, "%.0f_km", dis / 1000.0);
	else format(string, sizeof string, "%.0f_m", dis);
 	for(new i = 0; i < sizeof GPS_TD; i++)
 	{
		TextDrawShowForPlayer(playerid, GPS_TD[i]);
	}
	PlayerTextDrawSetString(playerid, GPS_PTD[playerid], string);
	PlayerTextDrawShow(playerid, GPS_PTD[playerid]);
	return 1;
}

DialogCreate:EditBizNameText(playerid)
{
	Dialog_Open(playerid, Dialog:EditBizName, DIALOG_STYLE_INPUT, !" ", "{FFFFFF}\
		   :\
	", !"", !"");
	return 1;
}

DialogResponse:EditBiz(playerid, response, listitem, inputtext[])
{
	new
	    index = EditPlayerBiz[playerid]
	;
	if(!response) return 1;
	switch(listitem)
	{
		case 0:
		{
			// - 
			
			new Float:x, Float:y, Float:z, Float:a;
			GetPlayerPos(playerid, x, y, z);
		    GetPlayerFacingAngle(playerid, a);
		    
			DestroyDynamicPickup(Biz[index][BIZ_PICKUP]);
			DestroyDynamicArea(Biz[index][BIZ_AREA]);
		    
			Biz[index][BIZ_X] = x;
			Biz[index][BIZ_Y] = y;
			Biz[index][BIZ_Z] = z;
			Biz[index][BIZ_A] = a;
			Biz[index][BIZ_PICKUP] = CreateDynamicPickup(19135, 23, x, y, z);
			Biz[index][BIZ_AREA] = CreateDynamicSphere(x, y, z, 1.5);
			AddGroupGoodAreas(BizGruop, Biz[index][BIZ_AREA], index);
			
			static const frm_query[] = "UPDATE `bizs` SET `x`='%.2f',`y`='%.2f',`z`='%.2f',`a`='%.2f' WHERE `id`='%d'";
			new query[sizeof frm_query + (14 - 2) * 4 + (12 - 2) + 1];
			format(query, sizeof query, frm_query, x, y, z, a, Biz[index][BIZ_ID]);
			mysql_tquery(connect, query);
			
			SCM(playerid, BRAND_GREEN, !"     ");
			
			new string[12];
			format(string, sizeof string, "%d", Biz[index][BIZ_ID]);
			callcmd::editbiz(playerid, string);
		}
		case 1:
		{
			// - 
			Dialog_Show(playerid, Dialog:EditBizNameText);
		}
		case 2:
		{
			// - 
			Dialog_Open(playerid, Dialog:EditBizType, DIALOG_STYLE_LIST, !" ", !"{FFFFFF}\
				\n\
				\n\
				\
			", !"", !"");
		}
		case 3:
		{
			// - 
			Dialog_Open(playerid, Dialog:EditBizInt, DIALOG_STYLE_INPUT, !" ", !"{FFFFFF}\
				 id :\
			", !"", !"");
		}
		case 4:
		{
			new Float:x, Float:y, Float:z;
			GetPlayerPos(playerid, x, y, z);
			
			DestroyDynamicCP(Biz[index][BIZ_CP]);
			if(Biz[index][BIZ_TYPE] == 2)
				Biz[index][BIZ_CP] = CreateDynamicCP(x, y, z, 2.0);
			else
				Biz[index][BIZ_CP] = CreateDynamicCP(x, y, z, 1.0, MAX_HOUSES + MAX_ENTERS + index);
			static const frm_query[] = "UPDATE `bizs` SET `use_x`='%.2f',`use_y`='%.2f',`use_z`='%.2f' WHERE `id`='%d'";
			new query[sizeof frm_query + (14 - 2) * 3 + (12 - 2) + 1];
			format(query, sizeof query, frm_query, x, y, z, Biz[index][BIZ_ID]);
			mysql_tquery(connect, query);

			SCM(playerid, BRAND_GREEN, !"     ");

			new string[12];
			format(string, sizeof string, "%d", Biz[index][BIZ_ID]);
			callcmd::editbiz(playerid, string);
		}
	}
	return 1;
}

DialogResponse:EditBizInt(playerid, response, listitem, inputtext[])
{
	new
	    index = EditPlayerBiz[playerid],
	    val = strval(inputtext)
	;
	if(response)
	{
		Biz[index][BIZ_INTERIOR] = val;
        db_UpdateData("bizs", "interior", val, Biz[index][BIZ_ID]);

		SCM(playerid, BRAND_GREEN, !"   ");
	}
	new string[12];
	format(string, sizeof string, "%d", Biz[index][BIZ_ID]);
	callcmd::editbiz(playerid, string);
	return 1;
}

DialogResponse:EditBizType(playerid, response, listitem, inputtext[])
{
	new index = EditPlayerBiz[playerid];
	if(response)
	{
		Biz[index][BIZ_TYPE] = listitem;
        db_UpdateData("bizs", "type", listitem, Biz[index][BIZ_ID]);
        
		SCM(playerid, BRAND_GREEN, !"   ");
	}
	new string[12];
	format(string, sizeof string, "%d", Biz[index][BIZ_ID]);
	callcmd::editbiz(playerid, string);
	return 1;
}

DialogResponse:EditBizName(playerid, response, listitem, inputtext[])
{
	new
	    len = strlen(inputtext),
	    index = EditPlayerBiz[playerid]
	;
	if(response)
	{
		if(len <= 0 || len >= MAX_BIZ_NAME)
		{
            Dialog_Show(playerid, Dialog:EditBizNameText);
            SCM(playerid, BRAND_RED, !"    1  40 ");
            return 1;
		}
		static const frm_query[] = "UPDATE `bizs` SET `name`='%s' WHERE `id`='%d'";
		new query[sizeof frm_query + (MAX_BIZ_NAME - 2) + (12 - 2) + 1];
		format(query, sizeof query, frm_query, inputtext, Biz[index][BIZ_ID]);
		mysql_tquery(connect, query);
		
		static const frm_str[] = "    %s  %s";
		new str[sizeof frm_str + (MAX_BIZ_NAME - 2) * 2 + 1];
		format(str, sizeof str, frm_str, Biz[index][BIZ_NAME], inputtext);
		SCM(playerid, BRAND_GREEN, str);
		
		format(Biz[index][BIZ_NAME], MAX_BIZ_NAME, inputtext);
	}
	new string[12];
	format(string, sizeof string, "%d", Biz[index][BIZ_ID]);
	callcmd::editbiz(playerid, string);
	return 1;
}

// ============================== [  ] ====================================

flags:s(CMD_CHAT);
flags:me(CMD_CHAT);
flags:do(CMD_CHAT);
flags:try(CMD_CHAT);

flags:a(CMD_ADMIN_1);
flags:answer(CMD_ADMIN_1);
flags:slap(CMD_ADMIN_1);
flags:kick(CMD_ADMIN_2);
flags:mute(CMD_ADMIN_2);
flags:unmute(CMD_ADMIN_2);
flags:veh(CMD_ADMIN_2);
flags:delveh(CMD_ADMIN_2);
flags:ban(CMD_ADMIN_3);
flags:unban(CMD_ADMIN_4);
flags:offban(CMD_ADMIN_4);
flags:money(CMD_ADMIN_7);
flags:payday(CMD_ADMIN_8);
flags:createhouse(CMD_ADMIN_8);
flags:edithouse(CMD_ADMIN_8);
flags:makeadmin(CMD_ADMIN_8);
flags:createbankomat(CMD_ADMIN_8);

// ============================== [  ] ==================================

cmd:mm(playerid)
{
    Dialog_Open(playerid, "MainMenu", DIALOG_STYLE_LIST, "{BC312E} ",  "\
		{BC312E}{FFFFFF} \n\
		{BC312E}{FFFFFF} \n\
		{BC312E}{FFFFFF}\
	", "", "");
	return 1;
}

cmd:admins(playerid)
{
	new string[400], count = 0;
	for(new i = 0; i < MAX_PLAYERS; i++)
	{
		if(!IsPlayerConnected(i)) continue;
		if(Player[i][P_ADM_LVL] < 1) continue;
		if(!IsPlayerAdminLogin(i)) continue;
		format(string, sizeof string, "%s%s[%d] - %dlvl\n", string, Player[i][P_NAME], i, Player[i][P_ADM_LVL]);
		count++;
	}
	if(count == 0) return SendClientMessage(playerid, 0xBEBEBEFF, "  ,   .");
	new caption[36];
	format(caption, sizeof caption, " : %d", count);
	Dialog_Message(playerid, caption, string, "Ok");
	return 1;
}

cmd:report(playerid)
{
	if(GetPVarInt(playerid, "report_time_block") > gettime()) return SendClientMessage(playerid, 0xBEBEBEFF, "     .");
	Dialog_Open(playerid, "SendReport", DIALOG_STYLE_INPUT, "/", "{FFFFFF}\
		          \n\
		{CD1445}     !\
	", "", "");
 	return 1;
}

// - 

cmd:engine(playerid)
{
	new veh = GetPlayerVehicleID(playerid);
	if(GetPlayerState(playerid) != PLAYER_STATE_DRIVER) return 0;
	if(VehNoEng(veh)) return 1;
	if(VehEngine{veh} == 1)
	{
	    callcmd::me(playerid, " ");
	    SetVehicleEngine(veh, 0);
	}
	else
	{
	    if(Vehicle[veh][V_FUEL] <= 0.0) return SendClientMessage(playerid, 0xBEBEBEFF, "    ");
	    callcmd::me(playerid, "  ");
	    SetTimerEx("VehicleEngineTimer", (random(2) + 1) * 1000, false, "dd", playerid, veh);
	}
	return 1;
}

cmd:light(playerid)
{
	if(GetPlayerState(playerid) != PLAYER_STATE_DRIVER) return 0;
	new veh = GetPlayerVehicleID(playerid);
	SetVehicleLight(veh, (VehLight{veh} == 1) ? 0 : 1);
	return 1;
}

public: VehicleEngineTimer(playerid, veh)
{
    callcmd::me(playerid, " ");
    SetVehicleEngine(veh, 1);
	return 1;
}

// - 

cmd:s(playerid, params[])
{
	new string[MAX_CHATBUBBLE_LENGTH];
	format(string, sizeof string, "%s : %s", Player[playerid][P_NAME], params);
    ProxDetector(playerid, 30.0, string);
	return 1;
}

cmd:me(playerid, params[])
{
	new string[MAX_CHATBUBBLE_LENGTH];
	format(string, sizeof string, "%s %s", Player[playerid][P_NAME], params);
    ProxDetector(playerid, 20.0, string, 0xE46EEAFF, 0xE46EEAFF);
	return 1;
}

cmd:do(playerid, params[])
{
	new string[MAX_CHATBUBBLE_LENGTH];
	format(string, sizeof string, "%s (( %s ))", params, Player[playerid][P_NAME]);
    ProxDetector(playerid, 20.0, string, 0xE46EEAFF, 0xE46EEAFF);
	return 1;
}

cmd:try(playerid, params[])
{
	new string[MAX_CHATBUBBLE_LENGTH];
	if(random(2)) format(string, sizeof string, "%s: %s [ {B0EA65}{FFFFFF} ]", Player[playerid][P_NAME], params);
	else format(string, sizeof string, "%s: %s [ {EA294D} {FFFFFF} ]", Player[playerid][P_NAME], params);
    ProxDetector(playerid, 20.0, string, -1, -1);
	return 1;
}

cmd:time(playerid)
{
	static const frm_str[] = " : %s";
	new string[sizeof frm_str + (50 - 2) + 1];
	format(string, sizeof string, frm_str, date(.timestamp = gettime() - 3 * 3600));
	Dialog_Message(playerid, "__", string, "Ok");
	return 1;
}

cmd:pay(playerid, params[])
{
	new user, money;
	if(sscanf(params, "ud", user, money)) return SendUseCommand(playerid, !": /pay [ id ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
	if(money <= 0) return SCM(playerid, 0xBEBEBEFF, !"   ");
	if(Player[playerid][P_MONEY] < money) return SCM(playerid, 0xBEBEBEFF, !"   ");
    if(!IsPlayerInRangeOfPlayer(playerid, user, 3.0)) return SCM(playerid, 0xBEBEBEFF, !"   ");
	switch(Player[playerid][P_LVL])
	{
	    case 0..3: if(money > 5000) return 0;
	    case 4..7: if(money > 15000) return 0;
	    case 8..14: if(money > 50000) return 0;
	    default: if(money > 75000) return 0;
	}
	if(GetPVarInt(playerid, !"LimitPay") > gettime()) return SCM(playerid, 0xBEBEBEFF, !"     ");
	SetPVarInt(playerid, !"LimitPay", gettime() + 60);
	
	Player[playerid][P_MONEY] -= money;
	Player[user][P_MONEY] += money;
	
	static const
		frm_str1[] = "  %s {5A9D36}$%d",
		frm_str2[] = " %s %s {5A9D36}$%d"
	;
	new
	    string1[sizeof frm_str1 + (MAX_PLAYER_NAME - 2) + ( 12 - 2) + 1],
	    string2[sizeof frm_str2 + (2 - 2) + (MAX_PLAYER_NAME - 2) + ( 12 - 2) + 1]
 	;
 	format(string1, sizeof string1, frm_str1, Player[user][P_NAME], money);
 	format(string2, sizeof string2, frm_str2, Player[playerid][P_GENDER] ? ("") : (""), Player[playerid][P_NAME], money);
 	SCM(playerid, BRAND_BLUE, string1);
 	SCM(user, BRAND_BLUE, string2);
	return 1;
}

cmd:gps(playerid)
{
	Dialog_Open(playerid, Dialog:GPS, DIALOG_STYLE_LIST, !"GPS", !"{FFFFFF}\
		\
	", !"", !"");
	return 1;
}

// -  

cmd:hmenu(playerid)
{
	static const frm_str[] = "{FFFFFF}\
		%s \n\
		  \n\
		  \
	";
	new
		string[sizeof frm_str + (7 - 2) + 1],
		index = -1
	;
	for(new i = 0; i < Houses; i++)
	{
		if(House[i][H_OWNER] == Player[playerid][P_ID])
		{
			index = i;
			break;
		}
	}
	if(index == -1) return 1;
	SetPVarInt(playerid, !"HouseIndex", index);
	format(string, sizeof string, frm_str, House[index][H_LOCK] ? ("") : (""));
	Dialog_Open(playerid, Dialog:HouseMenu, DIALOG_STYLE_LIST, !" ", string, !"", !"");
	return 1;
}

// - -

cmd:alogin(playerid)
{
	if(Player[playerid][P_ADM_LVL] == 0) return 0;
	if(IsPlayerAdminLogin(playerid))
	{
        PlayerAdminLogin{playerid} = 0;
        SendClientMessage(playerid, 0x527DBDFF, "   ");
        new string[34 + MAX_PLAYER_NAME];
        format(string, sizeof string, " %s  ", Player[playerid][P_NAME]);
        SendAdminMessage(0xEA3752FF, string);
	}
	else
	{
	    new string[48];
		format(string, sizeof string, "SELECT adm_pass FROM users WHERE id=%d", Player[playerid][P_ID]);
		new Cache:cache = mysql_query(connect, string);
		if(cache_get_row_count(connect) <= 0) {
            cache_delete(cache, connect);
            return 0;
		}
		new pass[65];
		cache_get_field_content(0, "adm_pass", pass);
		if(strcmp("null", pass) == 0)
		{
            Dialog_Show(playerid, "AdminCreatePassText");
		}
		else
		{
            Dialog_Show(playerid, "AdminLoginText");
		}
 	}
	return 1;
}

cmd:money(playerid, params[])
{
	new user, money;
	if(sscanf(params, "ud", user, money)) return SendUseCommand(playerid, !": /money [ id ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
	if(money == 0) return SCM(playerid, 0xBEBEBEFF, !"   ");
	Player[user][P_MONEY] += money;
	static const frm_str[] = "    %s  %d";
	new string[sizeof(frm_str) + (MAX_PLAYER_NAME - 2) + (12 - 2) + 1];
	format(string, sizeof string, frm_str, Player[playerid][P_NAME], money);
	SCM(user, 0xEA3752FF, string);

	static const frm_str2[] = " %s[%d]   %s[%d].  %d";
	new string2[sizeof(frm_str2) + ((MAX_PLAYER_NAME - 2) * 2) + ((5 - 2) * 2) +(12 - 2) + 1];
	format(string2, sizeof string2, frm_str2, Player[playerid][P_NAME], playerid, Player[user][P_NAME], user, money);
	SendAdminMessage(0xEA3752FF, string2);
	return 1;
}

cmd:a(playerid, params[])
{
	new string[MAX_CHATBUBBLE_LENGTH];
	if(strlen(params) < 1) return SendUseCommand(playerid, !": /a [  ]");
    format(string, sizeof string, "[adm]%s: %s", Player[playerid][P_NAME], params);
    SendAdminMessage(0xEA3752FF, string);
	return 1;
}

cmd:kick(playerid, params[])
{
	new user, reason[128];
	if(sscanf(params, "us[128]", user, reason)) return SendUseCommand(playerid, ": /kick [ id ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
	new string[144];
	format(string, sizeof string, "{FFFFFF}\
		    : %s\n\
		: %s\
	", Player[playerid][P_NAME], reason);
	Dialog_Message(user, " ", string, "Ok");
    format(string, sizeof string, " %s[%d]  %s[%d] | : %s", Player[playerid][P_NAME], playerid, Player[user][P_NAME], user, reason);
    SendAdminMessage(0xEA3752FF, string);
    KickEx(user);
	return 1;
}

cmd:ban(playerid, params[])
{
	new user, day, reason[128];
	if(sscanf(params, "uds[128]", user, day, reason)) return SendUseCommand(playerid, ": /ban [ id ] [ () ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
	if(day < 1 || day > 360) return SendClientMessage(playerid, 0xBEBEBEFF, "     1   360 ");
	new string[240];
	new time = gettime();
	new lost = time + (day * 3600 * 24);
	format(string, sizeof string, "{FFFFFF}\
		  : %s\n\
		 %d (%s)\n\
		: %s\
	", Player[playerid][P_NAME], day, date(.timestamp = lost), reason);
	Dialog_Message(user, " ", string, "Ok");
    format(string, sizeof string, " %s[%d]  %s[%d]  %d  | : %s", Player[playerid][P_NAME], playerid, Player[user][P_NAME], user, day, reason);
    SendAdminMessage(0xEA3752FF, string);
    KickEx(user);
	mysql_format(connect, string, sizeof string, "\
		INSERT INTO `ban_users`(`user`,`user_ip`,`admin`,`admin_ip`,`data`,`lost`,`reason`) VALUES ('%d','%s','%d','%s','%d','%d','%s')\
	", Player[user][P_ID], Player[user][P_IP], Player[playerid][P_ID], Player[playerid][P_IP], time, lost, reason);
	mysql_tquery(connect, string);
	return 1;
}

cmd:offban(playerid, params[])
{
	new user[MAX_PLAYER_NAME], day, reason[128];
	if(sscanf(params, "s[24]ds[128]", user, day, reason)) return SendUseCommand(playerid, ": /offban [  ] [ () ] [  ]");
	if(day < 1 || day > 360) return SendClientMessage(playerid, 0xBEBEBEFF, "     1   360 ");
	new string[240];
	new time = gettime();
	new lost = time + (day * 3600 * 24);
	new player;
	if(!sscanf(user, "u", player))
	{
		if(player != INVALID_PLAYER_ID) return SendClientMessage(playerid, 0xBEBEBEFF, " !");
	}
	mysql_format(connect, string, sizeof string, "SELECT `id` FROM `users` WHERE `name`='%s'", user);
	new Cache:cache = mysql_query(connect, string);
	if(cache_get_row_count(connect) <= 0) {
	    SendClientMessage(playerid, 0xBEBEBEFF, "  !");
		return cache_delete(cache);
	}
	new id = cache_get_field_content_int(0, "id");
	cache_delete(cache);
    format(string, sizeof string, " %s[%d]   %s  %d  | : %s", Player[playerid][P_NAME], playerid, user, day, reason);
    SendAdminMessage(0xEA3752FF, string);
	mysql_format(connect, string, sizeof string, "\
		INSERT INTO `ban_users`(`user`,`user_ip`,`admin`,`admin_ip`,`data`,`lost`,`reason`) VALUES ('%d','none','%d','%s','%d','%d','%s')\
	", id, Player[playerid][P_ID], Player[playerid][P_IP], time, lost, reason);
	mysql_tquery(connect, string);
	return 1;
}

cmd:unban(playerid, params[])
{
	new len = strlen(params);
	new string[108 + MAX_PLAYER_NAME];
	if(len < 4 || len > MAX_PLAYER_NAME) return SendClientMessage(playerid, 0xBEBEBEFF, "  !");
	mysql_format(connect, string, sizeof string, "\
		SELECT `users`.`id` FROM `users`,`ban_users` WHERE `users`.`name`='%s' AND `ban_users`.`user`=`users`.`id`\
	", params);
	new Cache:cache = mysql_query(connect, string);
	if(cache_get_row_count(connect) <= 0) {
	    SendClientMessage(playerid, 0xBEBEBEFF, "     !");
		return cache_delete(cache);
	}
	new id = cache_get_field_content_int(0, "id");
	cache_delete(cache);
	format(string, sizeof string, "DELETE FROM `ban_users` WHERE `user`='%d'", id);
 	mysql_tquery(connect, string);
 	format(string, sizeof string, " %s[%d]  %s", Player[playerid][P_NAME], playerid, params);
    SendAdminMessage(0xEA3752FF, string);
	return 1;
}

cmd:mute(playerid, params[])
{
	new user, time, reason[128];
	new string[144];
	if(sscanf(params, "uds[128]", user, time, reason)) return SendUseCommand(playerid, ": /mute [ id ] [ () ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
 	if(time < 1 || time > 180) return SendClientMessage(playerid, 0xBEBEBEFF, "     1   180 ");
 	if(Player[user][P_MUTE_TIME] != 0) return SendClientMessage(playerid, 0xBEBEBEFF, "    ");
	Player[user][P_MUTE_TIME] = time * 60;

    format(string, sizeof string, " %s[%d]   %s[%d]  %d . | : %s", Player[playerid][P_NAME], playerid, Player[user][P_NAME], user, time, reason);
    SendAdminMessage(0xEA3752FF, string);

    format(string, sizeof string, "   %s  %d . | : %s", Player[playerid][P_NAME], time, reason);
    SendClientMessage(user, 0xEA3752FF, string);
	return 1;
}

cmd:unmute(playerid, params[])
{
	new user;
	if(sscanf(params, "u", user)) return SendUseCommand(playerid, ": /unmute [ id ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
 	if(Player[user][P_MUTE_TIME] == 0) return SendClientMessage(playerid, 0xBEBEBEFF, "    ");
 	Player[user][P_MUTE_TIME] = 0;

	new string[144];

    format(string, sizeof string, " %s[%d]   %s[%d]", Player[playerid][P_NAME], playerid, Player[user][P_NAME], user);
    SendAdminMessage(0xEA3752FF, string);

    format(string, sizeof string, "   %s", Player[playerid][P_NAME]);
    SendClientMessage(user, 0xEA3752FF, string);
	return 1;
}

cmd:slap(playerid, params[])
{
	new user;
	if(sscanf(params, "u", user)) return SendUseCommand(playerid, ": /slap [ id ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
	new Float:x, Float:y, Float:z;
	GetPlayerPos(user, x, y, z);
	SetPlayerPos(user, x, y, z + 2.0);

	new string[144];

    format(string, sizeof string, " %s[%d]   %s[%d]", Player[playerid][P_NAME], playerid, Player[user][P_NAME], user);
    SendAdminMessage(0xEA3752FF, string);

    format(string, sizeof string, "    %s", Player[playerid][P_NAME]);
    SendClientMessage(user, 0xEA3752FF, string);
	return 1;
}

cmd:veh(playerid, params[])
{
	new model, col1, col2;
	if(sscanf(params, "ddd", model, col1, col2)) return SendUseCommand(playerid, ": /veh [  ] [  1 ] [  2 ]");
 	if(model < 400 || model > 611) return SendClientMessage(playerid, 0xBEBEBEFF, "     400   611");
 	if(col1 < 0 || col1 > 255 || col2 < 0 || col2 > 255) return SendClientMessage(playerid, 0xBEBEBEFF, "     0   255");
 	new Float:x, Float:y, Float:z, Float:a;
 	GetPlayerPos(playerid, x, y, z);
 	GetPlayerFacingAngle(playerid, a);
 	new veh = CreateVehicle(model, x, y, z, a, col1, col2, -1);
 	PutPlayerInVehicle(playerid, veh, 0);
 	SetVehicleEngine(veh, 1);
 	Vehicle[veh][V_FUEL] = 100.0;
 	AdminVehicle{veh} = 1;
	return 1;
}

cmd:delveh(playerid, params[])
{
	new veh = GetPlayerVehicleID(playerid);
    if(!sscanf(params, "d", veh))
    {
		if(!IsValidVehicle(veh)) veh = GetPlayerVehicleID(playerid);
	}
	else if(GetPlayerState(playerid) != PLAYER_STATE_DRIVER) return 1;
	if(AdminVehicle{veh} != 1) return SCM(playerid, 0xfbb034FF, !"     .");
	DestroyVehicle(veh);
	AdminVehicle{veh} = 0;
	SCM(playerid, 0xfbb034FF, !"  ");
	return 1;
}

cmd:delallveh(playerid, params[])
{
	static const frm_str[] = "     ,  %d";
	new
	    string[sizeof(frm_str) + (12 - 2) + 1],
	    count = 0
	;
	for(new i = 0; i < MAX_VEHICLES; i++)
	{
	    if(!IsValidVehicle(i)) continue;
		if(AdminVehicle{i} != 1) continue;
  		if(IsVehicleBuzy(i)) continue;
		DestroyVehicle(i);
		AdminVehicle{i} = 0;
		count++;
	}
	if(count == 0) return SCM(playerid, 0xfbb034FF, !"   ");
	format(string, sizeof string, frm_str, count);
	SCM(playerid, 0xfbb034FF, string);
	return 1;
}

cmd:setfuel(playerid, params[])
{
	new fuel;
	if(sscanf(params, "d", fuel)) return SendUseCommand(playerid, ": /setfuel [  ]");
	if(GetPlayerState(playerid) != PLAYER_STATE_DRIVER) return 0;
	new veh = GetPlayerVehicleID(playerid);
	Vehicle[veh][V_FUEL] = float(fuel);
	new string[60];
	format(string, sizeof string, "       %d", fuel);
	SendClientMessage(playerid, 0xBEBEBEFF, string);
	return 1;
}

cmd:answer(playerid, params[])
{
	new user, text[128];
    if(sscanf(params, "us[128]", user, text)) return SendUseCommand(playerid, ": /answer [ id ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);

    new string[MAX_CHATBUBBLE_LENGTH];

    format(string, sizeof string, "%s[%d]  %s[%d]: %s", Player[playerid][P_NAME], playerid, Player[user][P_NAME], user, text);
    SendAdminMessage(0xEA3752FF, string);

    format(string, sizeof string, "   %s: %s", Player[playerid][P_NAME], text);
    SendClientMessage(user, 0xEA3752FF, string);

	return 1;
}

cmd:payday(playerid)
{
	PayDay();
	SCM(playerid, BRAND_GREEN, "  PayDay");
	return 1;
}

cmd:createhouse(playerid)
{
	if(GetPlayerState(playerid) != PLAYER_STATE_ONFOOT) return 1;
	new Float:x, Float:y, Float:z, Float:a;
	GetPlayerPos(playerid, x, y, z);
 	GetPlayerFacingAngle(playerid, a);
 	new string[240];
 	format(string, sizeof string, "INSERT INTO `houses` (`id`,`x`,`y`,`z`,`a`) VALUES (NULL,'%.3f','%.3f','%.3f','%.3f')", x, y, z, a);
 	mysql_query(connect, string);
 	House[Houses][H_ID] = cache_insert_id();
 	House[Houses][H_PICKUP] = CreateDynamicPickup(1273, 23, x, y, z);
 	House[Houses][H_AREA] = CreateDynamicSphere(x, y, z, 1.5);
 	AddGroupGoodAreas(HouseGruop, House[Houses][H_AREA], Houses);
 	House[Houses][H_X] = x;
 	House[Houses][H_Y] = y;
 	House[Houses][H_Z] = z;
 	House[Houses][H_A] = a;
 	House[Houses][H_INTERIOR] = 1;
	House[Houses][H_PRICE] = 1;
	House[Houses][H_CLASS] = 1;
 	Houses++;
	return 1;
}

cmd:edithouse(playerid)
{
	new group, index;
	if(!GetPlayerGroupGoodAreaID(playerid, group, index))
	{
		SCM(playerid, 0xBEBEBEFF, !"    ");
		return 1;
	}
	if(HouseGruop != group)
	{
        SCM(playerid, 0xBEBEBEFF, !"    ");
		return 1;
	}
	static const frm_str[] = "\
		{f3f4f7} {0077c8}%d\n\
		{f3f4f7} {0077c8}%d\n\
		{f3f4f7} {0077c8}%d\
	";
	new string[sizeof(frm_str) + ((12 - 2) * 3) + 1];
	format(string, sizeof string, frm_str, House[index][H_INTERIOR], House[index][H_CLASS], House[index][H_PRICE]);
	Dialog_Open(playerid, Dialog:EditHouse, DIALOG_STYLE_LIST, !"{ff4c4c} ", string, !"", !"");
	SetPVarInt(playerid, !"HouseIndex", index);
	return 1;
}

cmd:makeadmin(playerid, params[])
{
	new
		user,
		level
	;
	if(sscanf(params, "ud", user, level)) return SendUseCommand(playerid, ": /makeadmin [ id ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
	if(user == playerid) return 1;
	if(level < 0 || level > 7) return SCM(playerid, 0xBEBEBEFF, !"     0  7");
	if(level == 0)
	{
		static const
			frm_str1[] = "%s[%d]  %s[%d]   ",
			frm_str2[] = "     %s"
		;
		if(Player[user][P_ADM_LVL] == 0) return SCM(playerid, 0xBEBEBEFF, !"     ");
		new
			string1[sizeof(frm_str1) + (MAX_PLAYER_NAME - 2) * 2 + (4 - 2) * 2 + 1],
			string2[sizeof(frm_str2) + (MAX_PLAYER_NAME - 2) + 1]
		;

	    format(string1, sizeof string1, frm_str1, Player[playerid][P_NAME], playerid, Player[user][P_NAME], user);
	    SendAdminMessage(0xEA3752FF, string1);

	    format(string2, sizeof string2, frm_str2, Player[playerid][P_NAME]);
	    SendClientMessage(user, 0xEA3752FF, string2);
	}
	else
	{
		if(level > Player[user][P_ADM_LVL])
		{
			static const
				frm_str1[] = "%s[%d]    %s[%d]  %d",
				frm_str2[] = "     %s  %d"
			;
			new
				string1[sizeof(frm_str1) + (MAX_PLAYER_NAME - 2) * 2 + (4 - 2) * 2 + (1 - 2) + 1],
				string2[sizeof(frm_str2) + (MAX_PLAYER_NAME - 2) + (1 - 2) + 1]
			;

		    format(string1, sizeof string1, frm_str1, Player[playerid][P_NAME], playerid, Player[user][P_NAME], user, level);
		    SendAdminMessage(0xEA3752FF, string1);

		    format(string2, sizeof string2, frm_str2, Player[playerid][P_NAME], level);
		    SendClientMessage(user, 0xEA3752FF, string2);
		}
		else if(level < Player[user][P_ADM_LVL])
		{
			static const
				frm_str1[] = "%s[%d]    %s[%d]  %d",
				frm_str2[] = "     %s  %d"
			;
			new
				string1[sizeof(frm_str1) + (MAX_PLAYER_NAME - 2) * 2 + (4 - 2) * 2 + (1 - 2) + 1],
				string2[sizeof(frm_str2) + (MAX_PLAYER_NAME - 2) + (1 - 2) + 1]
			;

		    format(string1, sizeof string1, frm_str1, Player[playerid][P_NAME], playerid, Player[user][P_NAME], user, level);
		    SendAdminMessage(0xEA3752FF, string1);

		    format(string2, sizeof string2, frm_str2, Player[playerid][P_NAME], level);
		    SendClientMessage(user, 0xEA3752FF, string2);
		}
		else
		{
		    SCM(playerid, 0xBEBEBEFF, !"    ");
			return 1;
		}
	}
	Player[user][P_ADM_LVL] = level;
	db_UpdateData("users", "adm_lvl", level, Player[user][P_ID]);
	return 1;
}

cmd:createbankomat(playerid)
{
	new Float:x, Float:y, Float:z, Float:a;
	GetPlayerPos(playerid, x, y, z);
    GetPlayerFacingAngle(playerid, a);
    GetXYBehindPoint(x, y, a, 2.0);
    new STREAMER_TAG_OBJECT:temp_obj = CreateDynamicObject(2942, x, y, z, 0.0, 0.0, 0.0);
    EditDynamicObject(playerid, temp_obj);
    SetPVarInt(playerid, !"EditBankomatObject", 1);
	return 1;
}

cmd:createbiz(playerid)
{
	new Float:x, Float:y, Float:z, Float:a;
	GetPlayerPos(playerid, x, y, z);
    GetPlayerFacingAngle(playerid, a);
    static const frm_query[] = "INSERT INTO `bizs`(`id`,`x`,`y`,`z`,`a`) VALUES (NULL,'%.2f','%.2f','%.2f','%.2f')";
    new query[sizeof frm_query + (14 - 4) * 4 + 1];
    format(query, sizeof query, frm_query, x, y, z, a);
    mysql_query(connect, query);
	Biz[Bizs][BIZ_ID] = cache_insert_id();
	Biz[Bizs][BIZ_OWNER] = 0;
	Biz[Bizs][BIZ_TYPE] = 0;
	Biz[Bizs][BIZ_INTERIOR] = 1;
	format(Biz[Bizs][BIZ_NAME], MAX_BIZ_NAME, "none");
	Biz[Bizs][BIZ_X] = x;
	Biz[Bizs][BIZ_Y] = y;
	Biz[Bizs][BIZ_Z] = z;
	Biz[Bizs][BIZ_A] = a;
	Biz[Bizs][BIZ_PICKUP] = CreateDynamicPickup(19135, 23, x, y, z);
	Biz[Bizs][BIZ_AREA] = CreateDynamicSphere(x, y, z, 1.5);
	AddGroupGoodAreas(BizGruop, Biz[Bizs][BIZ_AREA], Bizs);
	Bizs++;
	return 1;
}

cmd:editbiz(playerid, params[])
{
	new
		val = strval(params),
		index = -1
	;
	for(new i = 0; i < Bizs; i++)
	{
		if(Biz[i][BIZ_ID] != val) continue;
		index = i;
		break;
	}
	if(index == -1) return SCM(playerid, 0xBEBEBEFF, !"   id  ");

	static const frm_str[] = "\
		{D14840}1. {FFFFFF}  \n\
		{D14840}2. {FFFFFF}  {8FD11D}%s\n\
		{D14840}3. {FFFFFF}   {8FD11D}%s\n\
		{D14840}4. {FFFFFF}  {8FD11D}%d\n\
		{D14840}5. {FFFFFF}  \
	";
	new string[sizeof frm_str + (MAX_BIZ_NAME - 2) + (9 - 2) + (12 - 2) + 1];
	
	switch(Biz[index][BIZ_TYPE])
	{
		case 1: format(string, sizeof string, "");
		case 2: format(string, sizeof string, "");
		default: format(string, sizeof string, "");
	}
	
	format(string, sizeof string, frm_str, Biz[index][BIZ_NAME], string, Biz[index][BIZ_INTERIOR]);
	Dialog_Open(playerid, Dialog:EditBiz, DIALOG_STYLE_LIST, !" ", string, !"", !"");
	EditPlayerBiz[playerid] = index;
	return 1;
}

cmd:sethp(playerid, params[])
{
	new user, health;
	if(sscanf(params, "ud", user, health)) return SendUseCommand(playerid, ": /sethp [ id ] [  ]");
	if(user == INVALID_PLAYER_ID) return SendInvalidPlayer(playerid);
	if(health < 0 || health > 100) return SCM(playerid, 0xBEBEBEFF, !"     0   100");
	SetPlayerHealth(playerid, float(health));
	
	static const frm_str1[] = "    %s  %d";
	new string1[sizeof frm_str1 + (MAX_PLAYER_NAME - 2) + (12 - 2) + 1];
	format(string1, sizeof string1, frm_str1, Player[playerid][P_NAME], health);
	SCM(user, BRAND_GREEN, string1);
	
	static const frm_str2[] = " %s[%d]    %s[%d]  %d";
	new string2[sizeof frm_str2 + (MAX_PLAYER_NAME - 2) * 2 + (12 - 2) + 1];
	format(string2, sizeof string2, frm_str2, Player[playerid][P_NAME], Player[user][P_NAME], health);
	SendAdminMessage(0xEA3752FF, string2);
	return 1;
}

